// 2004/05/25 Shinigami

Unit Configure;

Interface
  Uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls,
  ComCtrls;

Type
  TConfigureForm = Class(TForm)
    UOPathLabel: TLabel;
    UOPathEdit: TEdit;
    ShardFolderButton: TButton;
    OSIFolderButton: TButton;
    ShardDiffFolderButton: TButton;
    MapControl: TPageControl;
    Britannia0Sheet: TTabSheet;
    Britannia0GroupBox: TGroupBox;
    Map0Label: TLabel;
    StaIdx0Label: TLabel;
    Statics0Label: TLabel;
    Map0Edit: TEdit;
    StaIdx0Edit: TEdit;
    Statics0Edit: TEdit;
    Britannia0DiffGroupBox: TGroupBox;
    MapDif0Label: TLabel;
    MapDifl0Label: TLabel;
    StaDif0Label: TLabel;
    StaDifi0Label: TLabel;
    StaDifl0Label: TLabel;
    MapDif0Edit: TEdit;
    MapDifl0Edit: TEdit;
    StaDif0Edit: TEdit;
    StaDifi0Edit: TEdit;
    StaDifl0Edit: TEdit;
    Britannia1DiffGroupBox: TGroupBox;
    MapDif1Label: TLabel;
    MapDifl1Label: TLabel;
    StaDif1Label: TLabel;
    StaDifi1Label: TLabel;
    StaDifl1Label: TLabel;
    MapDif1Edit: TEdit;
    MapDifl1Edit: TEdit;
    StaDif1Edit: TEdit;
    StaDifi1Edit: TEdit;
    StaDifl1Edit: TEdit;
    Britannia0OSIGroupBox: TGroupBox;
    OStaIdx0Label: TLabel;
    OStatics0Label: TLabel;
    OMap0Label: TLabel;
    OStaIdx0Edit: TEdit;
    OStatics0Edit: TEdit;
    OMap0Edit: TEdit;
    Illshenar2Sheet: TTabSheet;
    Illshenar2GroupBox: TGroupBox;
    Map2Label: TLabel;
    StaIdx2Label: TLabel;
    Statics2Label: TLabel;
    Map2Edit: TEdit;
    StaIdx2Edit: TEdit;
    Statics2Edit: TEdit;
    Illshenar2DiffGroupBox: TGroupBox;
    MapDif2Label: TLabel;
    MapDif2Edit: TEdit;
    MapDifl2Label: TLabel;
    MapDifl2Edit: TEdit;
    StaDif2Label: TLabel;
    StaDif2Edit: TEdit;
    StaDifi2Label: TLabel;
    StaDifi2Edit: TEdit;
    StaDifl2Label: TLabel;
    StaDifl2Edit: TEdit;
    Illshenar2OSIGroupBox: TGroupBox;
    OStaIdx2Label: TLabel;
    OStatics2Label: TLabel;
    OMap2Label: TLabel;
    OStaIdx2Edit: TEdit;
    OStatics2Edit: TEdit;
    OMap2Edit: TEdit;
    Malas3Sheet: TTabSheet;
    Malas3GroupBox: TGroupBox;
    Map3Label: TLabel;
    StaIdx3Label: TLabel;
    Statics3Label: TLabel;
    Map3Edit: TEdit;
    StaIdx3Edit: TEdit;
    Statics3Edit: TEdit;
    Malas3DiffGroupBox: TGroupBox;
    Malas3OSIGroupBox: TGroupBox;
    OStaIdx3Label: TLabel;
    OStatics3Label: TLabel;
    OMap3Label: TLabel;
    OStaIdx3Edit: TEdit;
    OStatics3Edit: TEdit;
    OMap3Edit: TEdit;
    Tokuno4Sheet: TTabSheet;
    Tokuno4GroupBox: TGroupBox;
    Map4Label: TLabel;
    StaIdx4Label: TLabel;
    Statics4Label: TLabel;
    Map4Edit: TEdit;
    StaIdx4Edit: TEdit;
    Statics4Edit: TEdit;
    Tokuno4DiffGroupBox: TGroupBox;
    Tokuno4OSIGroupBox: TGroupBox;
    OStaIdx4Label: TLabel;
    OStatics4Label: TLabel;
    OMap4Label: TLabel;
    OStaIdx4Edit: TEdit;
    OStatics4Edit: TEdit;
    OMap4Edit: TEdit;
    Procedure FormShow(Sender: TObject);
    Procedure FormClose(Sender: TObject; Var Action: TCloseAction);
    Procedure ShardFolderButtonClick(Sender: TObject);
    Procedure ShardDiffFolderButtonClick(Sender: TObject);
    Procedure OSIFolderButtonClick(Sender: TObject);
    Procedure FilenameChange(Sender: TObject);
    Procedure UOPathEditChange(Sender: TObject);
  End;

Var ConfigureForm: TConfigureForm;

Implementation
  Uses Registry, FileCtrl, Main;

{$R *.dfm}

Procedure TConfigureForm.FormShow(Sender: TObject);
Var Registry: TRegistry;
Begin
  Registry:=TRegistry.Create;
  Registry.OpenKey('\Software\Ridcully\WorldForge', False);

  Map0Edit.Text     :=Registry.ReadString('Map0.mul');
  StaIdx0Edit.Text  :=Registry.ReadString('StaIdx0.mul');
  Statics0Edit.Text :=Registry.ReadString('Statics0.mul');
  MapDif0Edit.Text  :=Registry.ReadString('MapDif0.mul');
  MapDifl0Edit.Text :=Registry.ReadString('MapDifl0.mul');
  StaDif0Edit.Text  :=Registry.ReadString('StaDif0.mul');
  StaDifi0Edit.Text :=Registry.ReadString('StaDifi0.mul');
  StaDifl0Edit.Text :=Registry.ReadString('StaDifl0.mul');
  MapDif1Edit.Text  :=Registry.ReadString('MapDif1.mul');
  MapDifl1Edit.Text :=Registry.ReadString('MapDifl1.mul');
  StaDif1Edit.Text  :=Registry.ReadString('StaDif1.mul');
  StaDifi1Edit.Text :=Registry.ReadString('StaDifi1.mul');
  StaDifl1Edit.Text :=Registry.ReadString('StaDifl1.mul');
  OMap0Edit.Text    :=Registry.ReadString('O-Map0.mul');
  OStaIdx0Edit.Text :=Registry.ReadString('O-StaIdx0.mul');
  OStatics0Edit.Text:=Registry.ReadString('O-Statics0.mul');

  Map2Edit.Text     :=Registry.ReadString('Map2.mul');
  StaIdx2Edit.Text  :=Registry.ReadString('StaIdx2.mul');
  Statics2Edit.Text :=Registry.ReadString('Statics2.mul');
  MapDif2Edit.Text  :=Registry.ReadString('MapDif2.mul');
  MapDifl2Edit.Text :=Registry.ReadString('MapDifl2.mul');
  StaDif2Edit.Text  :=Registry.ReadString('StaDif2.mul');
  StaDifi2Edit.Text :=Registry.ReadString('StaDifi2.mul');
  StaDifl2Edit.Text :=Registry.ReadString('StaDifl2.mul');
  OMap2Edit.Text    :=Registry.ReadString('O-Map2.mul');
  OStaIdx2Edit.Text :=Registry.ReadString('O-StaIdx2.mul');
  OStatics2Edit.Text:=Registry.ReadString('O-Statics2.mul');

  Map3Edit.Text     :=Registry.ReadString('Map3.mul');
  StaIdx3Edit.Text  :=Registry.ReadString('StaIdx3.mul');
  Statics3Edit.Text :=Registry.ReadString('Statics3.mul');
  OMap3Edit.Text    :=Registry.ReadString('O-Map3.mul');
  OStaIdx3Edit.Text :=Registry.ReadString('O-StaIdx3.mul');
  OStatics3Edit.Text:=Registry.ReadString('O-Statics3.mul');

  Map4Edit.Text     :=Registry.ReadString('Map4.mul');
  StaIdx4Edit.Text  :=Registry.ReadString('StaIdx4.mul');
  Statics4Edit.Text :=Registry.ReadString('Statics4.mul');
  OMap4Edit.Text    :=Registry.ReadString('O-Map4.mul');
  OStaIdx4Edit.Text :=Registry.ReadString('O-StaIdx4.mul');
  OStatics4Edit.Text:=Registry.ReadString('O-Statics4.mul');

  UOPathEdit.Text:=Registry.ReadString('UOPath');

  Registry.CloseKey;
  Registry.Free;
End;

Procedure TConfigureForm.FormClose(Sender: TObject; Var Action: TCloseAction);
Var StaIdxFileName, StaticsFileName, WSCFileName: String;
    Registry: TRegistry;
Begin
  If Application.MessageBox('You are sure to save settings?', 'Save settings', MB_YESNO)=IDYES Then Begin
    Registry:=TRegistry.Create;
    Registry.OpenKey('\Software\Ridcully\WorldForge', True);

    Registry.WriteString('Map0.mul',       Map0Edit.Text);
    Registry.WriteString('StaIdx0.mul',    StaIdx0Edit.Text);
    Registry.WriteString('Statics0.mul',   Statics0Edit.Text);
    Registry.WriteString('MapDif0.mul',    MapDif0Edit.Text);
    Registry.WriteString('MapDifl0.mul',   MapDifl0Edit.Text);
    Registry.WriteString('StaDif0.mul',    StaDif0Edit.Text);
    Registry.WriteString('StaDifi0.mul',   StaDifi0Edit.Text);
    Registry.WriteString('StaDifl0.mul',   StaDifl0Edit.Text);
    Registry.WriteString('MapDif1.mul',    MapDif1Edit.Text);
    Registry.WriteString('MapDifl1.mul',   MapDifl1Edit.Text);
    Registry.WriteString('StaDif1.mul',    StaDif1Edit.Text);
    Registry.WriteString('StaDifi1.mul',   StaDifi1Edit.Text);
    Registry.WriteString('StaDifl1.mul',   StaDifl1Edit.Text);
    Registry.WriteString('O-Map0.mul',     OMap0Edit.Text);
    Registry.WriteString('O-StaIdx0.mul',  OStaIdx0Edit.Text);
    Registry.WriteString('O-Statics0.mul', OStatics0Edit.Text);

    Registry.WriteString('Map2.mul',       Map2Edit.Text);
    Registry.WriteString('StaIdx2.mul',    StaIdx2Edit.Text);
    Registry.WriteString('Statics2.mul',   Statics2Edit.Text);
    Registry.WriteString('MapDif2.mul',    MapDif2Edit.Text);
    Registry.WriteString('MapDifl2.mul',   MapDifl2Edit.Text);
    Registry.WriteString('StaDif2.mul',    StaDif2Edit.Text);
    Registry.WriteString('StaDifi2.mul',   StaDifi2Edit.Text);
    Registry.WriteString('StaDifl2.mul',   StaDifl2Edit.Text);
    Registry.WriteString('O-Map2.mul',     OMap2Edit.Text);
    Registry.WriteString('O-StaIdx2.mul',  OStaIdx2Edit.Text);
    Registry.WriteString('O-Statics2.mul', OStatics2Edit.Text);

    Registry.WriteString('Map3.mul',       Map3Edit.Text);
    Registry.WriteString('StaIdx3.mul',    StaIdx3Edit.Text);
    Registry.WriteString('Statics3.mul',   Statics3Edit.Text);
    Registry.WriteString('O-Map3.mul',     OMap3Edit.Text);
    Registry.WriteString('O-StaIdx3.mul',  OStaIdx3Edit.Text);
    Registry.WriteString('O-Statics3.mul', OStatics3Edit.Text);

    Registry.WriteString('Map4.mul',       Map4Edit.Text);
    Registry.WriteString('StaIdx4.mul',    StaIdx4Edit.Text);
    Registry.WriteString('Statics4.mul',   Statics4Edit.Text);
    Registry.WriteString('O-Map4.mul',     OMap4Edit.Text);
    Registry.WriteString('O-StaIdx4.mul',  OStaIdx4Edit.Text);
    Registry.WriteString('O-Statics4.mul', OStatics4Edit.Text);

    Registry.WriteString('UOPath', UOPathEdit.Text);

    Registry.CloseKey;
    Registry.Free;

    // Configure Main-Window
    LoadFileNames(StaIdxFileName, StaticsFileName, WSCFileName);
    MainForm.StaIdxEdit.Text:=StaIdxFileName;
    MainForm.StaticsEdit.Text:=StaticsFileName;
    MainForm.WSCEdit.Text:=WSCFileName;
  End;
End;

Procedure TConfigureForm.ShardFolderButtonClick(Sender: TObject);
Var Folder: String;
Begin
  If SelectDirectory('Select Shard Folder...', '', Folder) Then
    If Application.MessageBox(PChar('You are sure to reset all Shard filenames to default names inside '''+
       Folder+''' ?'), 'Set Shard Folder', MB_YESNO)=IDYES Then Begin
      UOPathEdit.Text:=Folder;

      Map0Edit.Text    :=Folder+'\map0.mul';
      StaIdx0Edit.Text :=Folder+'\staidx0.mul';Statics0Edit.Text:=Folder+'\statics0.mul';

      Map2Edit.Text    :=Folder+'\map2.mul';
      StaIdx2Edit.Text :=Folder+'\staidx2.mul';Statics2Edit.Text:=Folder+'\statics2.mul';

      Map3Edit.Text    :=Folder+'\map3.mul';
      StaIdx3Edit.Text :=Folder+'\staidx3.mul';Statics3Edit.Text:=Folder+'\statics3.mul';

      Map4Edit.Text    :=Folder+'\map4.mul';
      StaIdx4Edit.Text :=Folder+'\staidx4.mul';Statics4Edit.Text:=Folder+'\statics4.mul';
    End;
End;

Procedure TConfigureForm.ShardDiffFolderButtonClick(Sender: TObject);
Var Folder: String;
Begin
  If SelectDirectory('Select Shard Diff Folder...', '', Folder) Then
    If Application.MessageBox(PChar('You are sure to reset all Shard Diff filenames to default names inside '''+
       Folder+''' ?'), 'Set Shard Diff Folder', MB_YESNO)=IDYES Then Begin
      MapDif0Edit.Text :=Folder+'\mapdif0.mul';MapDifl0Edit.Text:=Folder+'\mapdifl0.mul';
      StaDif0Edit.Text :=Folder+'\stadif0.mul';
      StaDifi0Edit.Text:=Folder+'\stadifi0.mul';StaDifl0Edit.Text:=Folder+'\stadifl0.mul';

      MapDif1Edit.Text :=Folder+'\mapdif1.mul';MapDifl1Edit.Text:=Folder+'\mapdifl1.mul';
      StaDif1Edit.Text :=Folder+'\stadif1.mul';
      StaDifi1Edit.Text:=Folder+'\stadifi1.mul';StaDifl1Edit.Text:=Folder+'\stadifl1.mul';

      MapDif2Edit.Text :=Folder+'\mapdif2.mul';MapDifl2Edit.Text:=Folder+'\mapdifl2.mul';
      StaDif2Edit.Text :=Folder+'\stadif2.mul';
      StaDifi2Edit.Text:=Folder+'\stadifi2.mul';StaDifl2Edit.Text:=Folder+'\stadifl2.mul';
    End;
End;

Procedure TConfigureForm.OSIFolderButtonClick(Sender: TObject);
Var Folder: String;
Begin
  If SelectDirectory('Select OSI Folder...', '', Folder) Then
    If Application.MessageBox(PChar('You are sure to reset all OSI filenames to default names inside '''+
       Folder+''' ?'), 'Set OSI Folder', MB_YESNO)=IDYES Then Begin
      OMap0Edit.Text    :=Folder+'\map0.mul';
      OStaIdx0Edit.Text :=Folder+'\staidx0.mul';OStatics0Edit.Text:=Folder+'\statics0.mul';

      OMap2Edit.Text    :=Folder+'\map2.mul';
      OStaIdx2Edit.Text :=Folder+'\staidx2.mul';OStatics2Edit.Text:=Folder+'\statics2.mul';

      OMap3Edit.Text    :=Folder+'\map3.mul';
      OStaIdx3Edit.Text :=Folder+'\staidx3.mul';OStatics3Edit.Text:=Folder+'\statics3.mul';

      OMap4Edit.Text    :=Folder+'\map4.mul';
      OStaIdx4Edit.Text :=Folder+'\staidx4.mul';OStatics4Edit.Text:=Folder+'\statics4.mul';
    End;
End;

Procedure TConfigureForm.FilenameChange(Sender: TObject);
Begin
  If FileExists(TEdit(Sender).Text) Then TEdit(Sender).Color:=clGreen Else TEdit(Sender).Color:=clRed;
End;

Procedure TConfigureForm.UOPathEditChange(Sender: TObject);
Begin
  If FileExists(UOPathEdit.Text+'\texidx.mul') And FileExists(UOPathEdit.Text+'\texmaps.mul') And
     FileExists(UOPathEdit.Text+'\artidx.mul') And FileExists(UOPathEdit.Text+'\art.mul') Then
    UOPathEdit.Color:=clGreen Else UOPathEdit.Color:=clRed;
End;

End.
