// Copyright (c) 1998, 1999, 2000 Jan Luebbe. All rights reserved.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Jan Luebbe can be emailed at jluebbe@lasnet.de

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//   WorldForge 6.4r4 - Aeon Edition / Pol Build by Shinigami/Birdy
//
//     Modificator:
//       Shinigami (Shinigami@gmx.net)   - http://www.welt-pergon.de
//       Birdy     (pol_birdy@yahoo.com) - http://www.polserver.com
//
//     Download latests ZIP from http://www.welt-pergon.de/downloads/WorldForgePol.zip
//
//   Modification:
//     2000/02/16 Shinigami: XYDiff eingefuegt, um groessere Bereiche zu Melt'en
//                           Tabs am Zeilenanfang sind nun erlaubt
//                           Pol-Schalter, der das EOF abschaltet
//     2001/11/01 Shinigami: BugFix beim Freeze
//     2004/05/06 Birdy:     Adding Width/Hight EditBoxes and RebuldButton
//                           Adding GenerateOSIDiff
//     2004/05/12 Shinigami: Integration in WF 6.4 Enviroment
//     2004/05/17 Shinigami: MapEdit - You can choose 3 different OSI-Map-Dimensions
//                           (it is not final, but WF will save different filenames)
//     2004/05/20 Shinigami: MapEdit - Bugfix - Stuff created in FormCreate should be destroyed in
//                           FormDestroy and not in FormClose
//                           MapEdit - MapMul uses a Cache mechanism to speed up
//                           (new Class TMulFile to support this feature)
//     2004/05/24 Shinigami: Enhancing Registry Entries to use Multiple Maps
//     2004/05/25 Shinigami: New Form 'Configure' to pre-set all Filenames
//                           WF-Diff uses Multiple Maps
//                           Simplify of FileCheck Functions
//                           WF-Diff - Additional Check of different O- and M-Files
//     2004/05/26 Shinigami: WF-Diff - You can switch between WF-Diff or OSI-Diff
//                           uomap.ocx will be registered by WF
//     2004/07/02 Shinigami: X/Y-UpDown-Buttons will work now
//                           ReWrite of CopyMap Function, incl. Usability
//                           MapFile is Sized-Checked now
//                           Freeze doesn't crash anymore... DynArray's don't like FillChar
//     2004/07/05 Shinigami: Realm-to-Realm MapCopy (and Bugfix because of endless Loop)
//                           Show Col & Row while moving inside Map using Keys
//     2004/07/06 Shinigami: You can switch between Realms inside MapForm directly
//                           Whole Application uses one 'Appath' and not 4 instances
//                           All ConfigFiles are moved to SubFolders
//                           Brushes can use up to 20x20 tiles now
//                           BrushesEdit will show choosen Brush
//                           Removed AutoHotKeys from TextureMenu so you don't have problems with larger lists
//                           Tiles in CustomBrushesForm are a little bit bigger
//                           Brushes DropDownBox will show up to 25 entries now
//                           Added a lot of TextureSets and Brushes made by SeBB from Pergon-Team
//     2005/01/11 Shinigami: Some small MultiMap-Bugfixes (in MapEdit and WF-Diff too)
//                           Added support for Tokuno
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

unit Main;

interface

uses
  Windows, Controls, Forms, ExtCtrls, Classes, ComCtrls, StdCtrls, Dialogs,
  Buttons, Menus, HelpFormUnit, Toolbox;

type
  TSysProgress = Procedure(Const Position: Integer);

  TMainForm = class(TForm)
    FileNamePanel: TPanel;
    StaIdxLabel: TLabel;
    StaIdxEdit: TEdit;
    StaticsLabel: TLabel;
    StaticsEdit: TEdit;
    WSCLabel: TLabel;
    WSCEdit: TEdit;
    ButtonPanel: TPanel;
    XLabel: TLabel;
    YLabel: TLabel;
    GetStaticIndexButton: TButton;
    GetStaticBlockButton: TButton;
    X1Edit: TEdit;
    Y1Edit: TEdit;
    X1UpDown: TUpDown;
    Y1UpDown: TUpDown;
    X2Edit: TEdit;
    X2UpDown: TUpDown;
    Y2Edit: TEdit;
    Y2UpDown: TUpDown;
    MeltBlockButton: TButton;
    FreezeWorldButton: TButton;
    MainPanel: TPanel;
    LogListBox: TListBox;
    MainPanelSplitter: TSplitter;
    ModeGroupBox: TGroupBox;
    NormalModeRadioButton: TRadioButton;
    SimpleModeRadioButton: TRadioButton;
    WritePATCheckBox: TCheckBox;
    PATSaveDialog: TSaveDialog;
    WFDiffButton: TButton;
    FillClearButton: TButton;
    SelectItemsRadioGroup: TRadioGroup;
    lblStatus: TLabel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    eXit1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Welcome1: TMenuItem;
    WelcometoWorldForge1: TMenuItem;
    MainListBox: TListBox;
    MapEditButton: TBitBtn;
    Extra1: TMenuItem;
    CreateemptyMap1: TMenuItem;
    ImportBitmap1: TMenuItem;
    ProgressBar: TProgressBar;
    PolStyle: TCheckBox;
    MapGroupBox: TGroupBox;
    MapComboBox: TComboBox;
    MapWidthEdit: TEdit;
    MapHeightEdit: TEdit;
    RebuildButton: TButton;
    WidthHeightLabel: TLabel;
    ConfigureButton: TButton;
    procedure GetStaticIndexButtonClick(Sender: TObject);
    procedure GetStaticBlockButtonClick(Sender: TObject);
    procedure MeltBlockButtonClick(Sender: TObject);
    procedure FreezeWorldButtonClick(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    Procedure FilenameChange(Sender: TObject);
    procedure X1EditExit(Sender: TObject);
    procedure Y1EditExit(Sender: TObject);
    procedure X1EditChange(Sender: TObject);
    procedure Y1EditChange(Sender: TObject);
    procedure X2EditExit(Sender: TObject);
    procedure Y2EditExit(Sender: TObject);
    procedure NormalModeRadioButtonClick(Sender: TObject);
    procedure SimpleModeRadioButtonClick(Sender: TObject);
    procedure WFDiffButtonClick(Sender: TObject);
    procedure FillClearButtonClick(Sender: TObject);
    procedure eXit1Click(Sender: TObject);
    procedure WelcometoWorldForge1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure MapEditButtonClick(Sender: TObject);
    procedure PolStyleClick(Sender: TObject);
    procedure MapComboBoxChange(Sender: TObject);
    procedure MapWidthEditExit(Sender: TObject);
    procedure MapHeightEditExit(Sender: TObject);
    procedure RebuildButtonClick(Sender: TObject);
    procedure ConfigureButtonClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
  Public
    MapWidth: Integer;
    MapHeight: Integer;
    MapSize: Integer;
    Appath: String;
  Private
    procedure UpdateEnabled;
    procedure UpdateTip;
  end;

  TMode = (Normal, Simple);
  TStep = (StaIdxName, StaticsName, WSCName, GetIndex, FreezeNow, Finished);
  TAction = (None, GettingIndex, GettingBlock, Melting, Freezeing);
  TBlockCoverage = (OutOfArea, PartlyInArea, CompletelyInArea);

Const
  Map0_Britannia          = 0;        // ComboBox-ItemID
  Map1_Britannia          = 1;
  Map2_Illshenar          = 2;
  Map3_Malas              = 3;
  Map4_Tokuno             = 4;

  Map0_Britannia_MaxX     = 6144;     // Map-Values
  Map0_Britannia_MaxY     = 4096;
  Map2_Illshenar_MaxX     = 2304;
  Map2_Illshenar_MaxY     = 1600;
  Map3_Malas_MaxX         = 2560; //2592; - hmm, wie kam ich nur dadrauf?
  Map3_Malas_MaxY         = 2048;
  Map4_Tokuno_MaxX        = 1448;
  Map4_Tokuno_MaxY        = 1448;

  Map0_Britannia_MapSize  = 77070336;
  Map0_Britannia_MapSizeB = 77096806; // Hmm, entstand nach einer Kopieraktion
  Map2_Illshenar_MapSize  = 11289600;
  Map3_Malas_MapSize      = 16056320;
  Map4_Tokuno_MapSize     = 6421156;

var
  MainForm: TMainForm;

type
  // Map?.mul
  TMapCell = packed record
    TileID: word;
    Altitude: shortint;
  end;
  TMapBlock = packed record
    Unknown: longword;
    Cells: array[0..7, 0..7] of TMapCell; // not x, y but y, x
  end;
  // StaIdx?.mul
  TStaticPointer = packed record
    Start, Length, Unknown: longword;
  end;
  // Statics?.mul
  TStaticRec = packed record
    ItemID: word;
    X, Y: byte;
    Z: shortint;
    Color: word;
  end;
  // Temp data
  TStaticIndex = Array of Array of TStaticPointer;
  TStaticBlock = packed record
    Count: word;
    Rec: packed array[1..2048] of TStaticRec; // 512 was too small
  end;
  // Private
  TSelectArrayRec = packed record
    Selected: boolean;
    XBlock, YBlock: word;
  end;
  TSelectArray = array[0..65535] of TSelectArrayRec;
  TAutoSelectArray = array[$0..$FFFF] of boolean;
  TBlockSelectArray = Array of Array of Boolean;

  MulFileType = file of byte;

var
  Starting: boolean = True;
  StaticIndex: TStaticIndex;
  StaticIndexLoaded: boolean = False;
  Mode: TMode;
  CurrentAction: TAction = None;
  PatchFinished: boolean = False;
  SICheck: shortint;
  ICheck: integer;
  AutoSelectArray: TAutoSelectArray;

// Support
function  CalcBlockCoverage(AreaTop, AreaLeft, AreaRight, AreaBottom: word; BlockX, BlockY: word): TBlockCoverage;

// AutoSelect.txt
procedure GetAutoSelect(const FileName: string; var AutoSelectBuffer: TAutoSelectArray);

// Map?.mul
procedure GetMapBlock(const FileName: string; XBlock, YBlock: word; var MapBlockBuffer: TMapBlock);
procedure SetMapBlock(const FileName: string; XBlock, YBlock: word; const MapBlockBuffer: TMapBlock);

// StaIdx?.mul
procedure GetStaticIndex(const FileName: string; var StaticIndexBuffer: TStaticIndex; const SysProgress: TSysProgress);
procedure PutStaticIndex(const FileName: string; var StaticIndexBuffer: TStaticIndex; const SysProgress: TSysProgress);

// Statics?.mul
procedure GetStaticBlock(const FileName: string; const StaticPointer: TStaticPointer; var StaticBlockBuffer: TStaticBlock);
procedure InsertIntoStaticBlock(var StaticBlock1: TStaticBlock; const StaticBlock2: TStaticBlock);
procedure PutStaticBlock(const FileName: string; var StaticPointer: TStaticPointer;  const StaticBlockBuffer: TStaticBlock);
procedure PutStaticBlockToFile(var MulFile: MulFileType; var StaticPointer: TStaticPointer;  const StaticBlockBuffer: TStaticBlock);

// UOX: *.wsc / Pol: *.cfg
Procedure FindHighestNumbers(Var WSCFile: TextFile; Var Number, Serial: LongInt);
Procedure SelectForExport(Const FileName: String; Var SelectArray: TSelectArray);
Procedure InsertStaticBlock(Const FileName: String; Const StaticBlock: TStaticBlock; Const XBl, YBl: Word);
Procedure ExtractStaticBlock(Const FileName: String; Var StaticBlock: TStaticBlock; Const SelectArray: TSelectArray; Const XBl, YBl: Word);

// Registry
Procedure LoadFileNames(Var StaIdxFileName, StaticsFileName, WSCFileName: String);
procedure SaveFileNames(const StaIdxFileName, StaticsFileName, WSCFileName: string);
function LoadMode: TMode;
procedure SaveMode(const NewMode: TMode);

// Global
Procedure Melt(Const StaIdxFileName, StaticsFileName, WSCFileName: String; Const X1, Y1, X2, Y2: Word; Const SysProgress: TSysProgress);
Procedure Freeze(Const StaIdxFileName, StaticsFileName, WSCFileName: String; Const SysProgress: TSysProgress);

// Logging
Procedure SysLog(Const LogText: String);
Procedure SysProgress(Const Position: Integer);

implementation

{$R *.DFM}

uses
  Messages, SysUtils, Graphics, Registry, Tools, WFDiff, WFFillClear, WFMapEdit, Configure,
  Progress;

// Support
function  CalcBlockCoverage(AreaTop, AreaLeft, AreaRight, AreaBottom: word; BlockX, BlockY: word): TBlockCoverage;
var
  BlockTop, BlockLeft, BlockRight, BlockBottom: word;
begin
  BlockTop := BlockY*8;
  BlockLeft := BlockX*8;
  BlockRight := BlockLeft+7;
  BlockBottom := BlockTop+7;

  if (AreaTop <= BlockTop) and
    (AreaLeft <= BlockLeft) and
    (AreaRight >= BlockRight) and
    (AreaBottom >= BlockBottom) then
  begin
    Result := CompletelyInArea;
    Exit;
  end;

  if (AreaTop > BlockBottom) or
    (AreaLeft > BlockRight) or
    (AreaRight < BlockLeft) or
    (AreaBottom < BlockTop) then
  begin
    Result := OutOfArea;
    Exit;
  end;

  Result := PartlyInArea;
end;

// AutoSelect.txt
procedure GetAutoSelect(const FileName: string; var AutoSelectBuffer: TAutoSelectArray);
var
  AutoSelectFile: TextFile;
  s, t: string;
  ItemID: word;
begin
  ZeroMemory(Addr(AutoSelectBuffer), SizeOf(TAutoSelectArray));
  AssignFile(AutoSelectFile, FileName);
  Reset(AutoSelectFile);
  while not Eof(AutoSelectFile) do
  begin
    Readln(AutoSelectFile, s);
    s := Trim(s);
    if not (s = '') then
      if not (s[1] = '#') then
      begin
        t := Trim(s[1]+s[2]+s[3]+s[4]+s[5]);
        ItemID := SpacedHexToInt(t, 2);
        AutoSelectBuffer[ItemID] := True;
      end;
  end;
  CloseFile(AutoSelectFile);
end;

// Map?.mul
// 2004/05/06 - Birdy
procedure GetMapBlock(const FileName: string; XBlock, YBlock: word; var MapBlockBuffer: TMapBlock);
var
  MapFile: file of byte;
begin
  ZeroMemory(Addr(MapBlockBuffer), SizeOf(TMapBlock));
  if XBlock > MainForm.MapWidth-1 then Exit;
  if YBlock > MainForm.MapHeight-1 then Exit;
  AssignFile(MapFile, FileName);
  Reset(MapFile);
  Seek(MapFile, (XBlock*MainForm.MapHeight+YBlock)*SizeOf(TMapBlock));
  BlockRead(MapFile, MapBlockBuffer, SizeOf(TMapBlock));
  CloseFile(MapFile);
end;

// 2004/05/06 - Birdy
procedure SetMapBlock(const FileName: string; XBlock, YBlock: word; const MapBlockBuffer: TMapBlock);
var
  MapFile: file of byte;
begin
  if XBlock > MainForm.MapWidth-1 then Exit;
  if YBlock > MainForm.MapHeight-1 then Exit;
  AssignFile(MapFile, FileName);
  Reset(MapFile);
  Seek(MapFile, (XBlock*MainForm.MapHeight+YBlock)*SizeOf(TMapBlock));
  BlockWrite(MapFile, MapBlockBuffer, SizeOf(TMapBlock));
  CloseFile(MapFile);
end;

// StaIdx?.mul
// 2004/05/06 - Birdy
procedure GetStaticIndex(const FileName: string; var StaticIndexBuffer: TStaticIndex; const SysProgress: TSysProgress);
var
  StaIdxFile: file of byte;
  X, Y: word;
begin
  SysProgress(0);
  AssignFile(StaIdxFile, FileName);
  Reset(StaIdxFile);
  for X := 0 to MainForm.MapWidth-1 do
  begin
    for Y := 0 to MainForm.MapHeight-1 do
    begin
      BlockRead(StaIdxFile, StaticIndexBuffer[X, Y], SizeOf(TStaticPointer));
    end;
    SysProgress(X*100 div MainForm.MapWidth);
    Application.ProcessMessages;
  end;
  CloseFile(StaIdxFile);
  StaticIndexLoaded := True;
  SysProgress(100);
end;

// 2004/05/06 - Birdy
procedure PutStaticIndex(const FileName: string; var StaticIndexBuffer: TStaticIndex; const SysProgress: TSysProgress);
var
  StaIdxFile: file of byte;
  X, Y: word;
begin
  AssignFile(StaIdxFile, FileName);
  Rewrite(StaIdxFile);
  for X := 0 to MainForm.MapWidth-1 do
  begin
    for Y := 0 to MainForm.MapHeight-1 do
    begin
      BlockWrite(StaIdxFile, StaticIndexBuffer[X, Y], SizeOf(TStaticPointer));
    end;
    SysProgress((X*10 div MainForm.MapWidth)+90);
    Application.ProcessMessages;
  end;
  CloseFile(StaIdxFile);
end;

// Statics?.mul
procedure GetStaticBlock(const FileName: string; const StaticPointer: TStaticPointer; var StaticBlockBuffer: TStaticBlock);
var
  StaticsFile: file of byte;
  //i: word;
begin
  //if (Action = GettingBlock) then MainForm.ProgressBar.Position := 0;
  ZeroMemory(Addr(StaticBlockBuffer), SizeOf(TStaticBlock));
  if StaticPointer.Start = $FFFFFFFF then Exit;
  AssignFile(StaticsFile, FileName);
  Reset(StaticsFile);
  Seek(StaticsFile, StaticPointer.Start);
  {for i := 1 to (StaticPointer.Length div 7) do
  begin
    BlockRead(StaticsFile, StaticBlockBuffer.Rec[i], SizeOf(TStaticRec));
    //if (Action = GettingBlock) then MainForm.ProgressBar.Position := (i*45 div (StaticPointer.Length div 7));
  end;}
  Assert(SizeOf(TStaticRec)=7, 'SizeOf() error in GetStaticBlock');
  if not ((StaticPointer.Length mod 7)=0) then
    raise Exception.Create('StaticPointer.Length is not a multiple of SizeOf(TStaticRec)');
  BlockRead(StaticsFile, StaticBlockBuffer.Rec, StaticPointer.Length);
  StaticBlockBuffer.Count := StaticPointer.Length div 7;
  CloseFile(StaticsFile);
  //if (Action = GettingBlock) then MainForm.ProgressBar.Position := 100;
end;

procedure InsertIntoStaticBlock(var StaticBlock1: TStaticBlock; const StaticBlock2: TStaticBlock);
var
  i: word;
begin
  for i := 1 to StaticBlock2.Count do
  begin
    StaticBlock1.Rec[StaticBlock1.Count+i] := StaticBlock2.Rec[i];
  end;
  Inc(StaticBlock1.Count, StaticBlock2.Count);
end;

// 2004/05/06 - Birdy
procedure PutStaticBlockToFile(var MulFile: MulFileType; var StaticPointer: TStaticPointer;  const StaticBlockBuffer: TStaticBlock);
begin
  Reset(MulFile);
  Seek(MulFile, FileSize(MulFile));
  StaticPointer.Start := FilePos(MulFile);
  StaticPointer.Length := StaticBlockBuffer.Count * 7;
  Assert(SizeOf(TStaticRec)=7, 'SizeOf() error in GetStaticBlock');
  if not ((StaticPointer.Length mod 7)=0) then
    raise Exception.Create('StaticPointer.Length is not a multiple of SizeOf(TStaticRec)');
  BlockWrite(MulFile, StaticBlockBuffer.Rec, StaticPointer.Length);
end;

procedure PutStaticBlock(const FileName: string; var StaticPointer: TStaticPointer;  const StaticBlockBuffer: TStaticBlock);
var
  StaticsFile: file of byte;
begin
  AssignFile(StaticsFile, FileName);
  Reset(StaticsFile);
  Seek(StaticsFile, FileSize(StaticsFile));
  StaticPointer.Start := FilePos(StaticsFile);
  StaticPointer.Length := StaticBlockBuffer.Count * 7;
  Assert(SizeOf(TStaticRec)=7, 'SizeOf() error in GetStaticBlock');
  if not ((StaticPointer.Length mod 7)=0) then
    raise Exception.Create('StaticPointer.Length is not a multiple of SizeOf(TStaticRec)');
  BlockWrite(StaticsFile, StaticBlockBuffer.Rec, StaticPointer.Length);
  CloseFile(StaticsFile);
end;
{var // i used this func in the wrong way!             
  StaticsFile: file of byte;
  i: word;
begin
  GetStaticBlock(FileName, StaticPointer, TempStaticBlock);
  for i := 1 to StaticBlockBuffer.Count do
  begin
    TempStaticBlock.Rec[TempStaticBlock.Count+i] := StaticBlockBuffer.Rec[i];
  end;
  Inc(TempStaticBlock.Count, StaticBlockBuffer.Count);
  AssignFile(StaticsFile, FileName);
  Reset(StaticsFile);
  Seek(StaticsFile, FileSize(StaticsFile));
  StaticPointer.Start := FilePos(StaticsFile);
  StaticPointer.Length := TempStaticBlock.Count * 7;
  for i := 1 to TempStaticBlock.Count do
    BlockWrite(StaticsFile, TempStaticBlock.Rec[i], SizeOf(TStaticRec));
  CloseFile(StaticsFile);
end;}

// *.wsc
// 2001/03/10 - Shinigami
Procedure FindHighestNumbers(Var WSCFile: TextFile; Var Number, Serial: LongInt);
Var Item      : LongInt;
    ItemSerial: LongInt;
    Stopped   : Boolean;
    UppLine   : String;
Begin
  Number:=-1;Serial:=$40000000;
  Item:=$ffff;

  Reset(WSCFile);Stopped:=False;
  While (Not EoF(WSCFile)) And (Not Stopped) Do Begin
    Readln(WSCFile, UppLine);UppLine:=UpperCase(Trim(UppLine));
    If UppLine<>'' Then
      If (UppLine<>'EOF') Then Begin
        Try
          If Pos('SECTION WORLDITEM', UppLine)=1 Then Begin
            Delete(UppLine, 1, 17);
            Item:=StrToInt(Trim(UppLine));
            If Number<Item Then Number:=Item;
          End Else
            If Pos('SERIAL', UppLine)=1 Then Begin
              Delete(UppLine, 1, 6);
              ItemSerial:=StrToInt(Trim(UppLine));
              If Serial<ItemSerial Then Serial:=ItemSerial;
            End;
        Except
          On ERangeError Do
            If Item=$ffff Then Raise Exception.Create('Invalid tag in a character section!') Else
              Raise Exception.Create('Invalid tag after "SECTION WORLDITEM '+IntToStr(Item)+'"');
        End;
      End Else Stopped:=True;
  End;
End;

// 2001/03/10 - Shinigami
Procedure SelectForExport(Const FileName: String; Var SelectArray: TSelectArray);
Var WSCFile   : TextFile;
    Item      : LongInt;
    ContBuffer: LongInt;
    Stopped   : Boolean;
    UppLine   : String;
    NameBuffer: String;
    IDBuffer  : Word;
    XBuffer   : Word;
    YBuffer   : Word;
    TypeBuffer: Word;
Begin
  If FileExists(FileName) Then Begin
    AssignFile(WSCFile, FileName);

    FillChar(SelectArray, SizeOf(TSelectArray), 0);
    Item:=$ffff;
    IDBuffer:=0;
    XBuffer:=0;
    YBuffer:=0;
    TypeBuffer:=0;
    ContBuffer:=0;

    Reset(WSCFile);Stopped:=False;
    While (Not EoF(WSCFile)) And (Not Stopped) Do Begin
      ReadLn(WSCFile, UppLine);UppLine:=UpperCase(Trim(UppLine));
      If UppLine<>'' Then
        If (UppLine<>'EOF') Then Begin
          Try
            If Pos('SECTION CHARACTER', UppLine)=1 Then Item:=$ffff Else
              If Pos('SECTION GUILD', UppLine)=1 Then Item:=$ffff Else
                If Pos('SECTION WORLDITEM', UppLine)=1 Then Begin
                  Delete(UppLine, 1, 17);
                  Item:=StrToInt(Trim(UppLine));
                  IDBuffer:=0;
                  XBuffer:=0;
                  YBuffer:=0;
                  TypeBuffer:=0;
                  ContBuffer:=0;
                End Else
                  If Pos('NAME', UppLine)=1 Then Begin
                    Delete(UppLine, 1, 4);
                    NameBuffer:=Trim(UppLine);
                  End Else
                    If Pos('ID', UppLine)=1 Then Begin
                      Delete(UppLine, 1, 2);
                      IDBuffer:=StrToInt(Trim(UppLine));
                    End Else
                      If Pos('X', UppLine)=1 Then Begin
                        Delete(UppLine, 1, 1);
                        XBuffer:=StrToInt(Trim(UppLine));
                      End Else
                        If Pos('Y', UppLine)=1 Then Begin
                          Delete(UppLine, 1, 1);
                          YBuffer:=StrToInt(Trim(UppLine));
                        End Else
                          If Pos('Z', UppLine)=1 Then Begin
                            Delete(UppLine, 1, 1);
                            StrToInt(Trim(UppLine)); // Nur 'n TypeCheck... weil sonst Exception
                          End Else
                            If Pos('CONT', UppLine)=1 Then Begin
                              Delete(UppLine, 1, 4);
                              ContBuffer:=StrToInt(Trim(UppLine));
                            End Else
                              If Pos('TYPE', UppLine)=1 Then Begin
                                Delete(UppLine, 1, 4);
                                TypeBuffer:=StrToInt(Trim(UppLine));
                              End Else
                                If (UppLine='}') And (Item<>$ffff) And (ContBuffer=-1) Then With SelectArray[Item] Do Begin
                                  Case MainForm.SelectItemsRadioGroup.ItemIndex of
                                    0: If TypeBuffer=255 Then Begin
                                         SysLog('Selecting item for export: '+IntToStr(Item));
                                         Selected:=True;
                                         XBlock:=XBuffer Div 8;
                                         YBlock:=YBuffer Div 8;
                                       End;
                                    1: If (TypeBuffer=255) Or (AutoSelectArray[IDBuffer] And
                                          (TypeBuffer=0) And (NameBuffer='#')) Then Begin
                                         SysLog('Selecting item for export: '+IntToStr(Item));
                                         Selected:=True;
                                         XBlock:=XBuffer Div 8;
                                         YBlock:=YBuffer Div 8;
                                       End;
                                  End;

                                  Item:=$ffff;
                                End;
          Except
            On ERangeError Do
              If Item=$ffff Then Raise Exception.Create('Invalid tag in a character section!') Else
                Raise Exception.Create('Invalid tag after "SECTION WORLDITEM '+IntToStr(Item)+'"');
          End;
        End Else Stopped:=True;
    End;

    CloseFile(WSCFile);
  End Else SysLog('Nothing to do!');
End;

// 2001/03/10 - Shinigami
Procedure InsertStaticBlock(Const FileName: String; Const StaticBlock: TStaticBlock; Const XBl, YBl: Word);
Var OldStrings: TStringList;
    WSCFile   : TextFile;
    Number    : LongInt;
    Serial    : Longint;
    Index     : Integer;
    Stopped   : Boolean;
    Tabbed    : Boolean;
    Line      : String;
Begin
  If StaticBlock.Count>0 Then Begin
    AssignFile(WSCFile, FileName);
    OldStrings:=TStringList.Create;

    If FileExists(FileName) Then Begin
      FindHighestNumbers(WSCFile, Number, Serial);
      SysLog('  Highest number: '+IntToStr(Number));
      SysLog('  Highest serial: '+IntToSpacedHex(Serial, 4));

      Reset(WSCFile);Stopped:=False;
      While (Not EoF(WSCFile)) And (Not Stopped) Do Begin
        Readln(WSCFile, Line);Line:=Trim(Line);
        If Line<>'' Then
          If (UpperCase(Line)='EOF') Then
            Stopped:=True Else OldStrings.Add(Line);
      End;
    End Else Begin
      Number:=1;Serial:=$40000000;
    End;

    Rewrite(WSCFile);

    Tabbed:=False;
    For Index:=0 To OldStrings.Count-1 Do Begin
      Line:=OldStrings[Index];
      If Line='{' Then Begin
        Writeln(WSCFile, '{');Tabbed:=True;
      End Else
        If Line='}' Then Begin
          Writeln(WSCFile, '}'#13#10);Tabbed:=False;
        End Else
          If Tabbed Then Writeln(WSCFile, #9+Line) Else Writeln(WSCFile, Line);
    End;

    For Index:=1 To StaticBlock.Count Do Begin
      Inc(Number);Inc(Serial);
      Writeln(WSCFile, 'SECTION WORLDITEM '+IntToStr(Number));
      Writeln(WSCFile, '{');
      Writeln(WSCFile, #9'SERIAL '+IntToStr(Serial));
      Writeln(WSCFile, #9'NAME #');
      Writeln(WSCFile, #9'ID '+IntToStr(StaticBlock.Rec[Index].ItemID));
      Writeln(WSCFile, #9'X '+IntToStr(StaticBlock.Rec[Index].X+XBl*8));
      Writeln(WSCFile, #9'Y '+IntToStr(StaticBlock.Rec[Index].Y+YBl*8));
      Writeln(WSCFile, #9'Z '+IntToStr(StaticBlock.Rec[Index].Z));
      Writeln(WSCFile, #9'COLOR '+IntToStr(StaticBlock.Rec[Index].Color));
      Writeln(WSCFile, #9'CONT -1');
      Writeln(WSCFile, #9'TYPE 255');
      Writeln(WSCFile, '}'#13#10);
    End;

    If Not MainForm.PolStyle.Checked Then Writeln(WSCFile, 'EOF');

    OldStrings.Free;
    CloseFile(WSCFile);
  End Else SysLog('Nothing to do!');
End;

// 2001/03/10 - Shinigami
Procedure ExtractStaticBlock(Const FileName: String; Var StaticBlock: TStaticBlock; Const SelectArray: TSelectArray; Const XBl, YBl: Word);
Var OldStrings : TStringList;
    WSCFile    : TextFile;
    ZBuffer    : ShortInt;
    Item       : LongInt;
    Index      : Integer;
    Stopped    : Boolean;
    Tabbed     : Boolean;
    Ignore     : Boolean;
    Line       : String;
    UppLine    : String;
    IDBuffer   : Word;
    XBuffer    : Word;
    YBuffer    : Word;
    ColorBuffer: Word;
Begin
  If FileExists(FileName) Then Begin
    AssignFile(WSCFile, FileName);
    OldStrings:=TStringList.Create;

    Reset(WSCFile);Stopped:=False;
    While (Not EoF(WSCFile)) And (Not Stopped) Do Begin
      Readln(WSCFile, Line);Line:=Trim(Line);
      If Line<>'' Then
        If (UpperCase(Line)='EOF') Then
          Stopped:=True Else OldStrings.Add(Line);
    End;

    StaticBlock.Count:=0;
    Item:=$ffff;
    IDBuffer:=0;
    XBuffer:=0;
    YBuffer:=0;
    ZBuffer:=0;
    ColorBuffer:=0;

    Rewrite(WSCFile);

    Ignore:=True;
    Tabbed:=False;
    For Index:=0 To OldStrings.Count-1 Do Begin
      Line:=OldStrings[Index];UppLine:=UpperCase(Line);

      Try
        If Pos('SECTION WORLDITEM', UppLine)=1 Then Begin
          Delete(UppLine, 1, 17);
          Item:=StrToInt(Trim(UppLine));
          With SelectArray[Item] Do
            If Selected And (XBlock=XBl) And (YBlock=YBl) Then Begin
              IDBuffer:=0;
              XBuffer:=0;
              YBuffer:=0;
              ZBuffer:=0;
              ColorBuffer:=0;

              Ignore:=False;
            End Else Ignore:=True;
        End;

        If Not Ignore Then Begin
          If Pos('ID', UppLine)=1 Then Begin
            Delete(UppLine, 1, 2);
            IDBuffer:=StrToInt(Trim(UppLine));
          End Else
            If Pos('X', UppLine)=1 Then Begin
              Delete(UppLine, 1, 1);
              XBuffer:=StrToInt(Trim(UppLine));
            End Else
              If Pos('Y', UppLine)=1 Then Begin
                Delete(UppLine, 1, 1);
                YBuffer:=StrToInt(Trim(UppLine));
              End Else
                If Pos('Z', UppLine)=1 Then Begin
                  Delete(UppLine, 1, 1);
                  ZBuffer:=StrToInt(Trim(UppLine));
                End Else
                  If Pos('COLOR', UppLine)=1 Then Begin
                    Delete(UppLine, 1, 5);
                    ColorBuffer:=StrToInt(Trim(UppLine));
                  End Else
                    If UppLine='}' Then With StaticBlock Do Begin
                      Inc(Count);
                      Rec[Count].ItemID:=IDBuffer;
                      Rec[Count].X:=XBuffer Mod 8;
                      Rec[Count].Y:=YBuffer Mod 8;
                      Rec[Count].Z:=ZBuffer;
                      Rec[Count].Color:=ColorBuffer;
                    End;
        End Else Begin
          If Line='{' Then Begin
            Writeln(WSCFile, '{');Tabbed:=True;
          End Else
            If Line='}' Then Begin
              Writeln(WSCFile, '}'#13#10);Tabbed:=False;
            End Else
              If Tabbed Then Writeln(WSCFile, #9+Line) Else Writeln(WSCFile, Line);
        End;
      Except
        On ERangeError Do
          If Item=$ffff Then Raise Exception.Create('Invalid tag in a character section!') Else
            Raise Exception.Create('Invalid tag after "SECTION WORLDITEM '+IntToStr(Item)+'"');
      End;
    End;

    OldStrings.Free;
    CloseFile(WSCFile);
  End Else SysLog('Nothing to do!');
End;

// Registry
// 2004/05/25 - Shinigami
Procedure LoadFileNames(Var StaIdxFileName, StaticsFileName, WSCFileName: String);
Var Registry: TRegistry;
Begin
  Registry:=TRegistry.Create;
  Registry.OpenKey('\Software\Ridcully\WorldForge', False);

  Case MainForm.MapComboBox.ItemIndex of
    Map0_Britannia: Begin
                      StaIdxFileName :=Registry.ReadString('StaIdx0.mul');  // StaDif0
                      StaticsFileName:=Registry.ReadString('Statics0.mul');
                    End;
    Map1_Britannia: Begin
                      StaIdxFileName :=Registry.ReadString('StaIdx0.mul');  // StaDif1
                      StaticsFileName:=Registry.ReadString('Statics0.mul');
                    End;
    Map2_Illshenar: Begin
                      StaIdxFileName :=Registry.ReadString('StaIdx2.mul');
                      StaticsFileName:=Registry.ReadString('Statics2.mul');
                    End;
    Map3_Malas:     Begin
                      StaIdxFileName :=Registry.ReadString('StaIdx3.mul');
                      StaticsFileName:=Registry.ReadString('Statics3.mul');
                    End;
    Map4_Tokuno:    Begin
                      StaIdxFileName :=Registry.ReadString('StaIdx4.mul');
                      StaticsFileName:=Registry.ReadString('Statics4.mul');
                    End;
  End;
  WSCFileName:=Registry.ReadString('UOX3.wsc');

  Registry.CloseKey;
  Registry.Free;
End;

// 2004/05/25 - Shinigami
Procedure SaveFileNames(Const StaIdxFileName, StaticsFileName, WSCFileName: String);
Var Registry: TRegistry;
Begin
  Registry:=TRegistry.Create;
  Registry.OpenKey('\Software\Ridcully\WorldForge', True);

  Case MainForm.MapComboBox.ItemIndex of
    Map0_Britannia: Begin
                      Registry.WriteString('StaIdx0.mul',  StaIdxFileName);  // StaDif0
                      Registry.WriteString('Statics0.mul', StaticsFileName);
                    End;
    Map1_Britannia: Begin
                      Registry.WriteString('StaIdx0.mul',  StaIdxFileName);  // StaDif1
                      Registry.WriteString('Statics0.mul', StaticsFileName);
                    End;
    Map2_Illshenar: Begin
                      Registry.WriteString('StaIdx2.mul',  StaIdxFileName);
                      Registry.WriteString('Statics2.mul', StaticsFileName);
                    End;
    Map3_Malas:     Begin
                      Registry.WriteString('StaIdx3.mul',  StaIdxFileName);
                      Registry.WriteString('Statics3.mul', StaticsFileName);
                    End;
    Map4_Tokuno:    Begin
                      Registry.WriteString('StaIdx4.mul',  StaIdxFileName);
                      Registry.WriteString('Statics4.mul', StaticsFileName);
                    End;
  End;
  Registry.WriteString('UOX3.wsc', WSCFileName);

  Registry.CloseKey;
  Registry.Free;
End;

// 2004/05/26 - Shinigami
Function LoadMode: TMode;
Var Registry: TRegistry;
Begin
  Registry:=TRegistry.Create;
  Registry.OpenKey('\Software\Ridcully\WorldForge', True);

  If Not Registry.ValueExists('Mode') Then Begin
    Case Application.MessageBox('You have not yet selected a mode. If you only want to use WorldForge for patching your files, you should select "Yes" (Simple mode). If you want all features, select "No" (Normal mode). In "Simple mode" you get step by step instructions on patching.', 'Simple mode?', MB_YESNO) of
      IDYES: Result:=Simple;
      IDNO:  Result:=Normal;
    Else
      Result:=Normal;
    End;

    Registry.WriteInteger('Mode', Integer(Result));

    Configure.ConfigureForm.ShowModal;
  End Else Result:=TMode(Registry.ReadInteger('Mode'));

  Registry.CloseKey;
  Registry.Free;
end;

procedure SaveMode(const NewMode: TMode);
var
  ARegistry: TRegistry;
begin
  ARegistry := TRegistry.Create;
  ARegistry.OpenKey('\Software\Ridcully\WorldForge', True);
  ARegistry.WriteInteger('Mode', Integer(NewMode));
  ARegistry.CloseKey;
  ARegistry.Free;
end;

// Global

// 2001/03/10 - Shinigami
Procedure Melt(Const StaIdxFileName, StaticsFileName, WSCFileName: String; Const X1, Y1, X2, Y2: Word; Const SysProgress: TSysProgress);
Var StaticBlock: TStaticBlock;
    X, Y       : Word;
Begin
  SysProgress(0);

  For X:=X1 To X2 Do
    For Y:=Y1 To Y2 Do Begin
      SysLog('Extracting from Statics... XBlock: '+IntToStr(X)+
        ' YBlock: '+IntToStr(Y)+'   Appending to WSC...');

      FillChar(StaticBlock, SizeOf(TStaticBlock), 0);
      GetStaticBlock(StaticsFileName, StaticIndex[X, Y], StaticBlock);
      InsertStaticBlock(WSCFileName, StaticBlock, X, Y);
      With StaticIndex[X, Y] Do Begin
        Start:=$ffffffff;Length:=0;Unknown:=0;
      End;
    End;

  SysLog('Writing StaIdx file...');
  PutStaticIndex(StaIdxFileName, StaticIndex, SysProgress);
  SysLog('Done!');

  SysProgress(100);
End;

// 2001/11/01 - Shinigami
// 2004/05/06 - Birdy
// 2004/07/02 - Shinigami: Bugfix... DynArrays don't like FillChar
Procedure Freeze(Const StaIdxFileName, StaticsFileName, WSCFileName: String; Const SysProgress: TSysProgress);
Var BlockSelectArray: TBlockSelectArray;
    SelectArray     : TSelectArray;
    WSCStaticBlock  : TStaticBlock;
    FileStaticBlock : TStaticBlock;
    BlocksToFreeze  : LongInt;
    BlocksFrozen    : LongInt;
    I, X, Y         : Word;
Begin
  SysProgress(0);

  SetLength(BlockSelectArray, MainForm.MapWidth, MainForm.MapHeight);
  For X:=0 To MainForm.MapWidth-1 Do
    For Y:=0 To MainForm.MapHeight-1 Do
      BlockSelectArray[X, Y]:=False;
  SelectForExport(WSCFileName, SelectArray);

  For I:=0 To 65535 Do
    If SelectArray[I].Selected Then Begin
      If (SelectArray[I].XBlock<=MainForm.MapWidth-1) And (SelectArray[I].YBlock<=MainForm.MapHeight-1) Then
        BlockSelectArray[SelectArray[I].XBlock, SelectArray[I].YBlock]:=True
      Else Raise Exception.Create('Invalid item in patch file! (Item#: '+IntToStr(I)+')')
    End;

  BlocksToFreeze:=0;
  For X:=0 To MainForm.MapWidth-1 Do
    For Y:=0 To MainForm.MapHeight-1 Do
      If BlockSelectArray[X, Y] Then Inc(BlocksToFreeze);

  BlocksFrozen:=0;
  For X:=0 To MainForm.MapWidth-1 Do
    For Y:=0 To MainForm.MapHeight-1 Do
      If BlockSelectArray[X, Y] Then Begin
        ZeroMemory(Addr(WSCStaticBlock), SizeOf(TStaticBlock)); // Should be removed

        SysLog('Extracting from WSC... XBlock: '+IntToStr(X)+' YBlock: '+IntToStr(Y)+'   Appending to Statics...');
        ExtractStaticBlock(WSCFileName, WSCStaticBlock, SelectArray, X, Y);
        GetStaticBlock(StaticsFileName, StaticIndex[X, Y], FileStaticBlock);
        InsertIntoStaticBlock(FileStaticBlock, WSCStaticBlock);
        PutStaticBlock(StaticsFileName, StaticIndex[X, Y], FileStaticBlock);

        If MainForm.WritePATCheckBox.Checked Then Begin
          SysLog('Appending to PAT-File... XBlock: '+IntToStr(X)+' YBlock: '+IntToStr(Y));
          InsertStaticBlock(MainForm.PATSaveDialog.FileName, WSCStaticBlock, X, Y);
        End;

        Inc(BlocksFrozen);
        SysProgress(BlocksFrozen*90 Div BlocksToFreeze);
        Application.ProcessMessages;
      End;

  SysLog('Writing staidx file...');
  PutStaticIndex(StaIdxFileName, StaticIndex, SysProgress);
  SysLog('Done!');

  SysProgress(100);
End;

// UI
procedure TMainForm.UpdateEnabled;
begin
  If (StaIdxEdit.Color=clGreen) And (StaticsEdit.Color=clGreen) Then Begin
    SaveFileNames(StaIdxEdit.Text, StaticsEdit.Text, '');
    WFDiffButton.Enabled:=True;
    FillClearButton.Enabled:=True;
  End Else Begin
    WFDiffButton.Enabled:=False;
    FillClearButton.Enabled:=False;
  End;

  If (StaIdxEdit.Color=clGreen) And (StaticsEdit.Color=clGreen) And (WSCEdit.Color=clGreen) Then Begin
    SaveFileNames(StaIdxEdit.Text, StaticsEdit.Text, WSCEdit.Text);

    If StaticIndexLoaded Then Begin
      GetStaticIndexButton.Enabled:=False;
      X1Edit.Enabled:=True;
      X1UpDown.Enabled:=True;
      X2Edit.Enabled:=True;
      X2UpDown.Enabled:=True;
      Y1Edit.Enabled:=True;
      Y1UpDown.Enabled:=True;
      Y2Edit.Enabled:=True;
      Y2UpDown.Enabled:=True;
      GetStaticBlockButton.Enabled:=True;
      MeltBlockButton.Enabled:=True;
      FreezeWorldButton.Enabled:=True;
      MapComboBox.Enabled:=False;
      MapWidthEdit.Enabled:=False;
      MapHeightEdit.Enabled:=False;
      RebuildButton.Enabled:=True;
    End Else Begin
      GetStaticIndexButton.Enabled:=True;
      X1Edit.Enabled:=False;
      X1UpDown.Enabled:=False;
      X2Edit.Enabled:=False;
      X2UpDown.Enabled:=False;
      Y1Edit.Enabled:=False;
      Y1UpDown.Enabled:=False;
      Y2Edit.Enabled:=False;
      Y2UpDown.Enabled:=False;
      GetStaticBlockButton.Enabled:=False;
      MeltBlockButton.Enabled:=False;
      FreezeWorldButton.Enabled:=False;
      MapComboBox.Enabled:=True;
      MapWidthEdit.Enabled:=True;
      MapHeightEdit.Enabled:=True;
      RebuildButton.Enabled:=False;
    End;
  End Else Begin
    GetStaticIndexButton.Enabled:=False;
    X1Edit.Enabled:=False;
    X1UpDown.Enabled:=False;
    X2Edit.Enabled:=False;
    X2UpDown.Enabled:=False;
    Y1Edit.Enabled:=False;
    Y1UpDown.Enabled:=False;
    Y2Edit.Enabled:=False;
    Y2UpDown.Enabled:=False;
    GetStaticBlockButton.Enabled:=False;
    MeltBlockButton.Enabled:=False;
    FreezeWorldButton.Enabled:=False;
    MapComboBox.Enabled:=True;
    MapWidthEdit.Enabled:=True;
    MapHeightEdit.Enabled:=True;
    RebuildButton.Enabled:=False;
  End;

  If Mode=Simple Then Begin
    X1Edit.Enabled:=False;
    X1UpDown.Enabled:=False;
    X2Edit.Enabled:=False;
    X2UpDown.Enabled:=False;
    Y1Edit.Enabled:=False;
    Y1UpDown.Enabled:=False;
    Y2Edit.Enabled:=False;
    Y2UpDown.Enabled:=False;
    GetStaticBlockButton.Enabled:=False;
    MeltBlockButton.Enabled:=False;
    MapComboBox.Enabled:=True;
    MapWidthEdit.Enabled:=True;
    MapHeightEdit.Enabled:=True;
    RebuildButton.Enabled:=False;
    If PatchFinished Then FreezeWorldButton.Enabled:=False;

    SelectItemsRadioGroup.Enabled:=False;
    WritePATCheckBox.Enabled:=False;
    FillClearButton.Enabled:=False;
    MapEditButton.Enabled:=False;
  End;
End;

procedure TMainForm.UpdateTip;
var
  NextStep: TStep;
begin
  if not (Mode = Simple) then Exit;
  if (StaIdxEdit.Color = clRed) then
    NextStep := StaIdxName
  else if (StaticsEdit.Color = clRed) then
    NextStep := StaticsName
  else if WSCEdit.Color = clRed then
    NextStep := WSCName
  else if not StaticIndexLoaded then
    NextStep := GetIndex
  else if not PatchFinished then
    NextStep := FreezeNow
  else
    NextStep := Finished;
  MainListBox.Items.Clear;
  case NextStep of
    StaIdxName:
    begin
      MainListBox.Items.Add('Please enter the path of your Staidx0.mul file in');
      MainListBox.Items.Add('the left box. It will turn green when WorldForge');
      MainListBox.Items.Add('found the file.');
    end;
    StaticsName:
    begin
      MainListBox.Items.Add('Please enter the path of your Statics0.mul file in');
      MainListBox.Items.Add('the middle box. It will turn green when WorldForge');
      MainListBox.Items.Add('found the file.');
    end;
    WSCName:
    begin
      MainListBox.Items.Add('Please enter the path of the file you got from');
      MainListBox.Items.Add('the server operator in the right box. It will');
      MainListBox.Items.Add('turn green when WorldForge found the file.');
    end;
    GetIndex:
    begin
      MainListBox.Items.Add('Click on the "GetStaticIndex"-button to the right.');
      MainListBox.Items.Add('This can take up to 30 seconds! Please wait until');
      MainListBox.Items.Add('WorldForge has finished.');
    end;
    FreezeNow:
    begin
      MainListBox.Items.Add('Click on the "Freeze"-button to the right.');
      MainListBox.Items.Add('This can take up to some minutes! Please wait until');
      MainListBox.Items.Add('WorldForge has finished.');
    end;
    Finished:
    begin
      MainListBox.Items.Add('Finished! You can now close WorldForge and connect to');
      MainListBox.Items.Add('the server. Enjoy!');
    end;
  end;
end;

// Events
// 2001/03/10 - Shinigami
Procedure TMainForm.GetStaticIndexButtonClick(Sender: TObject);
Begin
  MainForm.lblStatus.Color := clRed;
  MainForm.lblStatus.Caption := 'BUSY';
  SysLog('Init in progress... WorldForge may look crashed, do not interrupt!');
  GetStaticIndex(StaIdxEdit.Text, StaticIndex, SysProgress);
  StaIdxEdit.Enabled := False;
  StaticsEdit.Enabled := False;
  UpdateEnabled;
  UpdateTip;
  SysLog('Init completed!');
  MainForm.lblStatus.Color := clGreen;
  MainForm.lblStatus.Caption := 'READY';
End;

// 2001/03/10 - Shinigami
Procedure TMainForm.GetStaticBlockButtonClick(Sender: TObject);
Var StaticBlock: TStaticBlock;
    X, X1, X2  : Word;
    Y, Y1, Y2  : Word;
    I          : Word;
Begin
 // FreezeWorldButton.Enabled:=False; // Shinigami: Why?
  CurrentAction:=GettingBlock;
  MainListBox.Clear;

  X1:=StrToInt(X1Edit.Text);X2:=StrToInt(X2Edit.Text);
  Y1:=StrToInt(Y1Edit.Text);Y2:=StrToInt(Y2Edit.Text);
  X1:=X1 Div 8;X2:=X2 Div 8;Y1:=Y1 Div 8;Y2:=Y2 Div 8;
  X1Edit.Text:=IntToStr(X1*8);X2Edit.Text:=IntToStr(X2*8+7);
  Y1Edit.Text:=IntToStr(Y1*8);Y2Edit.Text:=IntToStr(Y2*8+7);

  For X:=X1 To X2 Do
    For Y:=Y1 To Y2 Do Begin
      FillChar(StaticBlock, SizeOf(TStaticBlock), 0);
      GetStaticBlock(StaticsEdit.Text, StaticIndex[X, Y], StaticBlock);

      For I:=1 To StaticBlock.Count Do
        MainListBox.Items.Add('Item #'+IntToStr(MainListBox.Items.Count+1)+': Item ID = '+
          IntToSpacedHex(StaticBlock.Rec[I].ItemID, 2)+', X = '+IntToStr(StaticBlock.Rec[I].X+X*8)+
          ', Y = '+IntToStr(StaticBlock.Rec[I].Y+Y*8)+', Z = '+IntToStr(StaticBlock.Rec[I].Z)+
          ', Color = '+IntToSpacedHex(StaticBlock.Rec[I].Color, 2));
    End;

  CurrentAction:=None;
End;

// 2001/03/10 - Shinigami
Procedure TMainForm.MeltBlockButtonClick(Sender: TObject);
Var X1, X2: Word;
    Y1, Y2: Word;
Begin
  CurrentAction:=Melting;
  MainForm.lblStatus.Color:=clRed;
  MainForm.lblStatus.Caption:='BUSY';
  SysLog('Melting in progress... WorldForge may look crashed, do not interrupt!');

  X1:=StrToInt(X1Edit.Text);X2:=StrToInt(X2Edit.Text);
  Y1:=StrToInt(Y1Edit.Text);Y2:=StrToInt(Y2Edit.Text);
  X1:=X1 Div 8;X2:=X2 Div 8;Y1:=Y1 Div 8;Y2:=Y2 Div 8;
  X1Edit.Text:=IntToStr(X1*8);X2Edit.Text:=IntToStr(X2*8+7);
  Y1Edit.Text:=IntToStr(Y1*8);Y2Edit.Text:=IntToStr(Y2*8+7);

  Melt(StaIdxEdit.Text, StaticsEdit.Text, WSCEdit.Text, X1, Y1, X2, Y2, SysProgress);
  SysLog('Melting completed!');
  MainForm.lblStatus.Color:=clGreen;
  MainForm.lblStatus.Caption:='READY';
  CurrentAction := None;
End;

procedure TMainForm.FreezeWorldButtonClick(Sender: TObject);
begin
  CurrentAction := Freezeing;
  MainForm.lblStatus.Color := clRed;
  MainForm.lblStatus.Caption := 'BUSY';
  SelectItemsRadioGroup.Enabled := False;
  WritePATCheckBox.Enabled := False;
  if WritePATCheckBox.Checked then
  begin
    if not PATSaveDialog.Execute then Exit;
    if UpperCase(PATSaveDialog.FileName) = UpperCase(WSCEdit.Text) then raise Exception.Create('The WSC and the PAT file cannot be the same!');
    if FileExists(PATSaveDialog.FileName) then
      case Application.MessageBox(PChar('Do you want to append new items to '+PATSaveDialog.FileName+'? All old items will remain in this file.'), PChar('Append to '+PATSaveDialog.FileName+'?'), MB_YESNO) of
        //IDYES: // normal weitermachen
        IDNO: Exit;
      end;
  end;
  if SelectItemsRadioGroup.ItemIndex = 1 then
    GetAutoSelect(ExtractFilePath(Application.ExeName)+'AutoSelect.txt', AutoSelectArray);
  SysLog('Freezing in progress... WorldForge may look crashed, do not interrupt!');
  Freeze(StaIdxEdit.Text, StaticsEdit.Text, WSCEdit.Text, SysProgress);
  PatchFinished := True;
  SysLog('Freezing completed!');
  MainForm.lblStatus.Color := clGreen;
  MainForm.lblStatus.Caption := 'READY';
  SelectItemsRadioGroup.Enabled := False;
  WritePATCheckBox.Enabled := False;
  UpdateEnabled;
  CurrentAction := None;
end;

// 2004/07/06 Shinigami: New
Procedure TMainForm.FormCreate(Sender: TObject);
Begin
  Appath:=ExtractFilePath(Application.ExeName)+'Config\';
End;

procedure TMainForm.FormShow(Sender: TObject);
Var StaIdxFileName, StaticsFileName, WSCFileName: String;
begin
  Starting := True;
  Mode:=LoadMode;
  LoadFileNames(StaIdxFileName, StaticsFileName, WSCFileName);
  case Mode of
    Normal:
    begin
      NormalModeRadioButton.Checked := True;
      Caption := Ver_Num +' (Normal mode) - Aeon Edition / Pol Build by Shinigami/Birdy';
    end;
    Simple:
    begin
      SimpleModeRadioButton.Checked := True;
      Caption := Ver_Num +' (Simple mode) - Aeon Edition / Pol Build by Shinigami/Birdy';
    end;
  end;
  StaIdxEdit.Text := StaIdxFileName;
  StaticsEdit.Text := StaticsFileName;
  WSCEdit.Text := WSCFileName;
  MapComboBoxChange(Sender);
  PolStyleClick(Sender);

  With MainListBox Do
    SendMessage(Handle, LB_SETTOPINDEX, Items.Count-1, 0);

  Starting := False;
end;

Procedure TMainForm.FilenameChange(Sender: TObject);
Begin
  If FileExists(TEdit(Sender).Text) Then TEdit(Sender).Color:=clGreen Else TEdit(Sender).Color:=clRed;
  UpdateEnabled;
  UpdateTip;
End;

Procedure TMainForm.X1EditChange(Sender: TObject);
Begin
  If X1Edit.Text<>'' Then Begin
    X2UpDown.Min:=StrToInt(X1Edit.Text);X2EditExit(Sender);
  End;
End;

Procedure TMainForm.X1EditExit(Sender: TObject);
Var Wert: Integer;
Begin
  Wert:=StrToInt(X1Edit.Text);
  If Wert>X1UpDown.Max Then X1Edit.Text:=IntToStr(X1UpDown.Max);
  If Wert<X1UpDown.Min Then X1Edit.Text:=IntToStr(X1UpDown.Min);
  X2UpDown.Min:=StrToInt(X1Edit.Text);X2EditExit(Sender);
End;

Procedure TMainForm.Y1EditChange(Sender: TObject);
Begin
  If Y1Edit.Text<>'' Then Begin
    Y2UpDown.Min:=StrToInt(Y1Edit.Text);Y2EditExit(Sender);
  End;
End;

Procedure TMainForm.Y1EditExit(Sender: TObject);
Var Wert: Integer;
Begin
  Wert:=StrToInt(Y1Edit.Text);
  If Wert>Y1UpDown.Max Then Y1Edit.Text:=IntToStr(Y1UpDown.Max);
  If Wert<Y1UpDown.Min Then Y1Edit.Text:=IntToStr(Y1UpDown.Min);
  Y2UpDown.Min:=StrToInt(Y1Edit.Text);Y2EditExit(Sender);
End;

Procedure TMainForm.X2EditExit(Sender: TObject);
Var Wert: Integer;
Begin
  Wert:=StrToInt(X2Edit.Text);
  If Wert>X2UpDown.Max Then X2Edit.Text:=IntToStr(X2UpDown.Max);
  If Wert<X2UpDown.Min Then X2Edit.Text:=IntToStr(X2UpDown.Min);
End;

Procedure TMainForm.Y2EditExit(Sender: TObject);
Var Wert: Integer;
Begin
  Wert:=StrToInt(Y2Edit.Text);
  If Wert>Y2UpDown.Max Then Y2Edit.Text:=IntToStr(Y2UpDown.Max);
  If Wert<Y2UpDown.Min Then Y2Edit.Text:=IntToStr(Y2UpDown.Min);
End;

procedure TMainForm.NormalModeRadioButtonClick(Sender: TObject);
begin
  if NormalModeRadioButton.Checked and not Starting then
  begin
    SaveMode(Normal);
    Application.MessageBox('The new mode will be active the next time you start WorldForge.', 'Normal mode selected', MB_OK)
  end;
end;

procedure TMainForm.SimpleModeRadioButtonClick(Sender: TObject);
begin
  if SimpleModeRadioButton.Checked and not Starting then
  begin
    SaveMode(Simple);
    Application.MessageBox('The new mode will be active the next time you start WorldForge.', 'Simple mode selected', MB_OK)
  end;
end;

procedure TMainForm.WFDiffButtonClick(Sender: TObject);
begin
  UpdateEnabled;
  UpdateTip;
  WFDiff.WFDiffForm.ShowModal;
end;

procedure TMainForm.FillClearButtonClick(Sender: TObject);
begin
  WFFillClear.WFFillClearForm.ShowModal;
end;

procedure TMainForm.eXit1Click(Sender: TObject);
begin
	Close;
end;

procedure TMainForm.WelcometoWorldForge1Click(Sender: TObject);
var
	HelpForm : tHelpForm;
begin
	HelpForm := tHelpForm.Create( Nil );
   HelpForm.Read_Help_File(1);
   HelpForm.Show;
end;

procedure TMainForm.SpeedButton1Click(Sender: TObject);
begin
	Close;
end;

procedure TMainForm.MapEditButtonClick(Sender: TObject);
begin
  WFMapEdit.WFMapEditForm.Show;
end;

Procedure SysLog(Const LogText: String);
Begin
  With MainForm.LogListBox Do Begin
    Items.Add(LogText);
    SendMessage(Handle, LB_SETTOPINDEX, Items.Count-1, 0);
  End;
End;

Procedure SysProgress(Const Position: Integer);
Begin
  MainForm.ProgressBar.Position:=Position;
End;

Procedure TMainForm.PolStyleClick(Sender: TObject);
Begin
  If PolStyle.Checked Then
    WSCLabel.Caption:='statics.cfg' Else WSCLabel.Caption:='items.wsc';
End;

// 2004/05/12 - Shinigami
// 2004/07/02 - Shinigami: Vereinfachung...
Procedure TMainForm.MapComboBoxChange(Sender: TObject);
Var MaxX, MaxY: Integer;
    MapID     : Char;
Begin
  Case MapComboBox.ItemIndex of
    Map0_Britannia: Begin
                      MaxX:=Map0_Britannia_MaxX;MaxY:=Map0_Britannia_MaxY;
                      MapID:=IntToStr(Map0_Britannia)[1];MapSize:=Map0_Britannia_MapSize;
                    End;
    Map1_Britannia: Begin
                      MaxX:=Map0_Britannia_MaxX;MaxY:=Map0_Britannia_MaxY;
                      MapID:=IntToStr(Map0_Britannia)[1];MapSize:=Map0_Britannia_MapSize;
                    End;
    Map2_Illshenar: Begin
                      MaxX:=Map2_Illshenar_MaxX;MaxY:=Map2_Illshenar_MaxY;
                      MapID:=IntToStr(Map2_Illshenar)[1];MapSize:=Map2_Illshenar_MapSize;
                    End;
    Map3_Malas:     Begin
                      MaxX:=Map3_Malas_MaxX;MaxY:=Map3_Malas_MaxY;
                      MapID:=IntToStr(Map3_Malas)[1];MapSize:=Map3_Malas_MapSize;
                    End;
    Map4_Tokuno:    Begin
                      MaxX:=Map4_Tokuno_MaxX;MaxY:=Map4_Tokuno_MaxY;
                      MapID:=IntToStr(Map4_Tokuno)[1];MapSize:=Map4_Tokuno_MapSize;
                    End;
    Else            Begin
                      MaxX:=Map0_Britannia_MaxX;MaxY:=Map0_Britannia_MaxY;
                      MapID:=IntToStr(Map0_Britannia)[1];MapSize:=Map0_Britannia_MapSize;
                    End;
  End;

  MapWidthEdit.Text:=IntToStr(MaxX);MapHeightEdit.Text:=IntToStr(MaxY);
  StaIdxEdit.Text:=ExtractFilePath(StaIdxEdit.Text)+'staidx'+MapID+'.mul';
  StaticsEdit.Text:=ExtractFilePath(StaticsEdit.Text)+'statics'+MapID+'.mul';
  StaIdxLabel.Caption:='StaIdx'+MapID+'.mul';StaticsLabel.Caption:='Statics'+MapID+'.mul';

  MapWidthEditExit(Sender);MapHeightEditExit(Sender);

  WFMapEditForm.MapComboBox.ItemIndex:=MapComboBox.ItemIndex;
  If MapComboBox.ItemIndex<0 Then WFMapEditForm.Caption:='MapEdit - undefiniert' Else
    WFMapEditForm.Caption:='MapEdit - '+MapComboBox.Items[MapComboBox.ItemIndex];
End;

// 2004/05/06 - Birdy
// 2004/05/15 - Shinigami
// 2004/07/02 - Shinigami: X1/2UpDown.Max wird nun auch gesetzt
Procedure TMainForm.MapWidthEditExit(Sender: TObject);
Var NewMapWidth: Integer;
Begin
  If (Not TryStrToInt(MapWidthEdit.Text, NewMapWidth)) Or
     (1>NewMapWidth) Or (NewMapWidth>Map0_Britannia_MaxX) Then NewMapWidth:=Map0_Britannia_MaxX;

  MapWidth:=NewMapWidth Div 8;
  If NewMapWidth Mod 8>0 Then Inc(MapWidth);
  NewMapWidth:=MapWidth*8;

  MapWidthEdit.Text:=IntToStr(NewMapWidth);
  X1UpDown.Max:=NewMapWidth;X2UpDown.Max:=NewMapWidth;
  WFMapEditForm.SX1UpDown.Max:=NewMapWidth;WFMapEditForm.SX2UpDown.Max:=NewMapWidth; // MapCopy

  If (High(StaticIndex)<>MapWidth) Or (High(StaticIndex[0])<>MapHeight) Then
    SetLength(StaticIndex, MapWidth, MapHeight);
End;

// 2004/05/06 - Birdy
// 2004/05/15 - Shinigami
// 2004/07/02 - Shinigami: Y1/2UpDown.Max wird nun auch gesetzt
Procedure TMainForm.MapHeightEditExit(Sender: TObject);
Var NewMapHeight: Integer;
Begin
  If (Not TryStrToInt(MapHeightEdit.Text, NewMapHeight)) Or
     (1>NewMapHeight) Or (NewMapHeight>Map0_Britannia_MaxY) Then NewMapHeight:=Map0_Britannia_MaxY;

  MapHeight:=NewMapHeight Div 8;
  If NewMapHeight Mod 8>0 Then Inc(MapHeight);
  NewMapHeight:=MapHeight*8;

  MapHeightEdit.Text:=IntToStr(NewMapHeight);
  Y1UpDown.Max:=NewMapHeight;Y2UpDown.Max:=NewMapHeight;
  WFMapEditForm.SY1UpDown.Max:=NewMapHeight;WFMapEditForm.SY2UpDown.Max:=NewMapHeight; // MapCopy

  If (High(StaticIndex)<>MapWidth) Or (High(StaticIndex[0])<>MapHeight) Then
    SetLength(StaticIndex, MapWidth, MapHeight);
End;

// 2004/05/06 - Birdy
procedure TMainForm.RebuildButtonClick(Sender: TObject);
var
  StaticsFile: MulFileType;
  X, Y: word;
  StaticsFileName: String;
  FileStaticBlock : TStaticBlock;
begin
  MainForm.lblStatus.Color := clRed;
  MainForm.lblStatus.Caption := 'BUSY';
  SysLog('Rebuild in progress... WorldForge may look crashed, do not interrupt!');

  AssignFile(StaticsFile, MainForm.StaticsEdit.Text+'_rebuilt');
  Rewrite(StaticsFile);

  StaticsFileName := MainForm.StaticsEdit.Text;

  for X := 0 to MapWidth-1 do
  begin
    for Y := 0 to MapHeight-1 do
    begin
      if not (StaticIndex[X, Y].Start = $FFFFFFFF) then
        begin
          GetStaticBlock(StaticsFileName, StaticIndex[X, Y], FileStaticBlock);
          PutStaticBlockToFile(StaticsFile, StaticIndex[X, Y], FileStaticBlock);
        end;
    end;
    SysProgress(X*100 div MapWidth);
    Application.ProcessMessages;
  end;
  CloseFile(StaticsFile);
  SysProgress(100);

  PutStaticIndex(MainForm.StaIdxEdit.Text+'_rebuilt', StaticIndex, SysProgress);
  SysProgress(0);

  SysLog('Rebuild completed!');
  MainForm.lblStatus.Color := clGreen;
  MainForm.lblStatus.Caption := 'READY';
end;

// 2004/05/26 - Shinigami
Procedure TMainForm.ConfigureButtonClick(Sender: TObject);
Begin
  Configure.ConfigureForm.Show;
End;

// 2004/05/26 - Shinigami
Procedure TMainForm.About1Click(Sender: TObject);
Begin
  Application.MessageBox('This is a special WorldForge - supports Pol feature too... For questions etc. please contact shinigami@gmx.net', 'WorldForge', MB_OK);
End;

end.
