unit WFDlgAddTile;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Grids, ExtCtrls;

type
  TWFFAddTile = class(TForm)
    btnAddID: TSpeedButton;
    smallDrawGrid: TStringGrid;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    edAddTile: TLabeledEdit;
    procedure FormCreate(Sender: TObject);
    procedure smallDrawGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure btnAddIDClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  WFFAddTile: TWFFAddTile;

function LoadTexture(const TileID: word; var bitmap: TBitmap):boolean;
function LoadArt(const TileID: word; var bitmap: TBitmap):boolean;

implementation

{$R *.dfm}
uses Tools, WFMapEdit, Main;

// Temp hier lassen!
function LoadTexture(const TileID: word; var Bitmap: TBitmap):boolean;
var
  TexIdxFile: file of byte;
  TexMapsFile: file of byte;
  TexturePointer: TTexturePointer;
  TextureBuffer: TTextureBuffer;
  SideLength, X, Y: integer;
  P: PByteArray;
begin
  //if (not FileNamesCorrect) or (TileID >= 16382) then
  if (not FileNamesCorrect) or (TileID >= 4096) then
  begin
    Result := False;
    Exit;
  end;
  AssignFile(TexIdxFile, WFMapEditForm.UOPathEdit.Text+'\texidx.mul');
  Reset(TexIdxFile);
  Seek(TexIdxFile, TileID*12);
  BlockRead(TexIdxFile, TexturePointer, SizeOf(TTexturePointer));
  CloseFile(TexIdxFile);
  case TexturePointer.Length of
    $2000: SideLength := 64;
    $8000: SideLength := 128;
  else
    Result := False;
    Exit;
  end;
  AssignFile(TexMapsFile, WFMapEditForm.UOPathEdit.Text+'\texmaps.mul');
  Reset(TexMapsFile);
  Seek(TexMapsFile, TexturePointer.Start);
  BlockRead(TexMapsFile, TextureBuffer, TexturePointer.Length);
  CloseFile(TexMapsFile);
  // Reading file done
  Bitmap.Width := SideLength;
  Bitmap.Height := SideLength;
  Bitmap.PixelFormat := pf15bit;
  {$R-}
  begin
    for Y := 0 to SideLength-1 do
    begin
      P := Bitmap.ScanLine[Y];
      for X := 0 to SideLength-1 do
      begin
        P[X*2{15Bit}  ] := TextureBuffer[(Y*SideLength+X)*2  ];
        P[X*2{15Bit}+1] := TextureBuffer[(Y*SideLength+X)*2+1];
      end;
    end;
  end;
  {$R+}
  Result := True;
end;

//hoenie
function LoadArt(const TileID: word; var Bitmap: TBitmap):boolean;
var
  ArtIdxFile: file of byte;
  ArtFile: file of byte;
  ArtPointer: TArtPointer;
  TempArray: array[0..16382] of byte;
  // TempArray: array[0..2047] of byte;
  TempMap: array[0..45, 0..45, 0..1] of byte;
  i, X, Y, XStart, YStart: integer;
  P: PByteArray;
begin
  Result:=False;
	case tileid of
   	$0007,$0008:exit;
   end;
  if (not FileNamesCorrect) or (TileID >= 16382) then
  //if (not FileNamesCorrect) or (TileID >= 4096) then
  begin
    Result := False;
    Exit;
  end;
  AssignFile(ArtIdxFile, WFMapEditForm.UOPathEdit.Text+'\artidx.mul');
  Reset(ArtIdxFile);
  Seek(ArtIdxFile, TileID*12);
  BlockRead(ArtIdxFile, ArtPointer, SizeOf(TArtPointer));
  CloseFile(ArtIdxFile);
  if (ArtPointer.Start = $FFFFFFFF) or
    not (ArtPointer.Length = 2048) then
  begin
    Result := False;
    Exit;
  end;
  AssignFile(ArtFile, WFMapEditForm.UOPathEdit.Text+'\art.mul');
  Reset(ArtFile);
  Seek(ArtFile, ArtPointer.Start);
  BlockRead(ArtFile, TempArray, ArtPointer.Length-4);
  CloseFile(ArtFile);
  // Reading file done
  Bitmap.Width := 45;
  Bitmap.Height := 45;
  Bitmap.PixelFormat := pf15bit;
  Bitmap.Canvas.Brush.Color := clBlack;
  Bitmap.Canvas.FillRect(Bitmap.Canvas.ClipRect);

  i := 0;
  XStart := 0;
  YStart := 1;

  ZeroMemory(Addr(TempMap), SizeOf(TempMap));

  {$R-}
  while True do
  begin
    X := XStart;
    Y := YStart;
    while (X <= 44) and (Y >= 0) do
    begin
      TempMap[X, Y][0] := TempArray[i];
      TempMap[X, Y][1] := TempArray[i+1];
      TempMap[X+1, Y][0] := TempArray[i];
      TempMap[X+1, Y][1] := TempArray[i+1];
      TempMap[X, Y+1][0] := TempArray[i];
      TempMap[X, Y+1][1] := TempArray[i+1];
      Inc(i, 2);
      Inc(X, 1);
      Dec(Y, 1);
    end;
    if YStart < 43 then
    begin
      Inc(YStart, 2);
    end
    else if YStart = 43 then
    begin
      Inc(YStart, 1);
      Inc(XStart, 1);
    end
    else // YStart = 44
    begin
      Inc(XStart, 2);
    end;
    if XStart > 43 then Break;
  end;

  begin
    for Y := 0 to 44 do
    begin
      P := Bitmap.ScanLine[Y];
      for X := 0 to 44 do
      begin
        P[X*2{15Bit}  ] := TempMap[X, Y][0];
        P[X*2{15Bit}+1] := TempMap[X, Y][1];
      end;
    end;
  end;
  {$R+}

  Result := True;
end;

procedure TWFFAddTile.FormCreate(Sender: TObject);
var
  i : Integer;
  idlist : TStringList;
  ahex : string;
  aint : integer;
begin
  idlist := TStringList.Create;
  idlist.LoadFromFile(MainForm.Appath+'Textures\tileids.lst');
  smallDrawGrid.RowCount := idlist.Count;
  for i := 0 to smallDrawGrid.RowCount-1 do
  begin
    aint := StrToInt(copy(idlist[i],Pos('=',idlist[i])+1,length(idlist[0])));
    ahex := IntToHex(aint,4);
    smallDrawGrid.Cells[0,i] := ahex;
  end;
  idlist.Free;
  smallDrawGrid.Repaint;
end;

procedure TWFFAddTile.smallDrawGridDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  Bitmap: TBitmap;
  id : integer;
begin
  Bitmap := TBitmap.Create;
  Bitmap.Width := 1; // LoadXYZ sets them
  Bitmap.Height := 1;
  Bitmap.PixelFormat := pf15bit;
  //SortedTextureGrid.
  id := StrToInt('$'+copy(smallDrawGrid.Rows[ARow].Text,0,4));
  if not LoadTexture(id, Bitmap) then
    if not LoadArt(id, Bitmap) then
    begin
    end;
  smallDrawGrid.Canvas.StretchDraw(Rect, Bitmap);
  if gdSelected	in State then
  begin
    smallDrawGrid.Canvas.Pen.Color := clRed;
    smallDrawGrid.Canvas.Brush.Style := bsClear;
    smallDrawGrid.Canvas.Rectangle(Rect);
  end;
  smallDrawGrid.Canvas.Brush.Style := bsSolid;
  smallDrawGrid.Canvas.Brush.Color := clWhite; // default
  smallDrawGrid.Canvas.TextOut(Rect.Left+1, Rect.Top+1, ' '+IntToSpacedHex(id, 2)+' ');
  Bitmap.Free;
end;

procedure TWFFAddTile.btnAddIDClick(Sender: TObject);
begin
  edAddTile.Text := '$'+copy(smallDrawGrid.Rows[smallDrawGrid.Row].Text,0,4);
end;

end.
