unit WFDlgCustomBrush;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, Buttons, ComCtrls, ExtCtrls, Menus;

type
  TWFCustomBrush = class(TForm)
    cbCustomBrushes: TComboBox;
    edBrushName: TLabeledEdit;
    Label1: TLabel;
    BrushGrid: TStringGrid;
    udRows: TUpDown;
    udCols: TUpDown;
    edRows: TLabeledEdit;
    edCols: TLabeledEdit;
    Panel1: TPanel;
    Panel2: TPanel;
    Label13: TLabel;
    btnFind: TSpeedButton;
    btnCustomTextures: TSpeedButton;
    edFindID: TEdit;
    smallDrawGrid: TStringGrid;
    Panel3: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    cbShowID: TCheckBox;
    pmCustomTextures: TPopupMenu;
    procedure FormCreate(Sender: TObject);
    Procedure FormShow(Sender: TObject);
    procedure BrushGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure edBrushNameChange(Sender: TObject);
    procedure smallDrawGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure smallDrawGridClick(Sender: TObject);
    procedure BrushGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure udRowsClick(Sender: TObject; Button: TUDBtnType);
    procedure udColsClick(Sender: TObject; Button: TUDBtnType);
    procedure btnFindClick(Sender: TObject);
    procedure cbShowIDClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure cbCustomBrushesChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    FBrush : TStringList;
    function findRow(id : integer): integer;
    procedure loadBrush(BrushName : String);
  public
    { Public declarations }
  end;

var
  WFCustomBrush: TWFCustomBrush;

function LoadTexture(const TileID: word; var bitmap: TBitmap):boolean;
function LoadArt(const TileID: word; var bitmap: TBitmap):boolean;
function FileNamesCorrect:boolean;

implementation

{$R *.dfm}
{$R bmp.res}

uses Tools, WFMapEdit, Main, WFTools;

function LoadTexture(const TileID: word; var Bitmap: TBitmap):boolean;
var
  TexIdxFile: file of byte;
  TexMapsFile: file of byte;
  TexturePointer: TTexturePointer;
  TextureBuffer: TTextureBuffer;
  SideLength, X, Y: integer;
  P: PByteArray;
begin
  //if (not FileNamesCorrect) or (TileID >= 16382) then
  if (not FileNamesCorrect) or (TileID >= 4096) then
  begin
    Result := False;
    Exit;
  end;
  AssignFile(TexIdxFile, WFMapEditForm.UOPathEdit.Text+'\texidx.mul');
  Reset(TexIdxFile);
  Seek(TexIdxFile, TileID*12);
  BlockRead(TexIdxFile, TexturePointer, SizeOf(TTexturePointer));
  CloseFile(TexIdxFile);
  case TexturePointer.Length of
    $2000: SideLength := 64;
    $8000: SideLength := 128;
  else
    Result := False;
    Exit;
  end;
  AssignFile(TexMapsFile, WFMapEditForm.UOPathEdit.Text+'\texmaps.mul');
  Reset(TexMapsFile);
  Seek(TexMapsFile, TexturePointer.Start);
  BlockRead(TexMapsFile, TextureBuffer, TexturePointer.Length);
  CloseFile(TexMapsFile);
  // Reading file done
  Bitmap.Width := SideLength;
  Bitmap.Height := SideLength;
  Bitmap.PixelFormat := pf15bit;
  {$R-}
  begin
    for Y := 0 to SideLength-1 do
    begin
      P := Bitmap.ScanLine[Y];
      for X := 0 to SideLength-1 do
      begin
        P[X*2{15Bit}  ] := TextureBuffer[(Y*SideLength+X)*2  ];
        P[X*2{15Bit}+1] := TextureBuffer[(Y*SideLength+X)*2+1];
      end;
    end;
  end;
  {$R+}
  Result := True;
end;

//hoenie
function LoadArt(const TileID: word; var Bitmap: TBitmap):boolean;
var
  ArtIdxFile: file of byte;
  ArtFile: file of byte;
  ArtPointer: TArtPointer;
  TempArray: array[0..16382] of byte;
  // TempArray: array[0..2047] of byte;
  TempMap: array[0..45, 0..45, 0..1] of byte;
  i, X, Y, XStart, YStart: integer;
  P: PByteArray;
begin
  Result:=False;
	case tileid of
   	$0007,$0008:exit;
   end;
  if (not FileNamesCorrect) or (TileID >= 16382) then
  //if (not FileNamesCorrect) or (TileID >= 4096) then
  begin
    Result := False;
    Exit;
  end;
  AssignFile(ArtIdxFile, WFMapEditForm.UOPathEdit.Text+'\artidx.mul');
  Reset(ArtIdxFile);
  Seek(ArtIdxFile, TileID*12);
  BlockRead(ArtIdxFile, ArtPointer, SizeOf(TArtPointer));
  CloseFile(ArtIdxFile);
  if (ArtPointer.Start = $FFFFFFFF) or
    not (ArtPointer.Length = 2048) then
  begin
    Result := False;
    Exit;
  end;
  AssignFile(ArtFile, WFMapEditForm.UOPathEdit.Text+'\art.mul');
  Reset(ArtFile);
  Seek(ArtFile, ArtPointer.Start);
  BlockRead(ArtFile, TempArray, ArtPointer.Length-4);
  CloseFile(ArtFile);
  // Reading file done
  Bitmap.Width := 45;
  Bitmap.Height := 45;
  Bitmap.PixelFormat := pf15bit;
  Bitmap.Canvas.Brush.Color := clBlack;
  Bitmap.Canvas.FillRect(Bitmap.Canvas.ClipRect);

  i := 0;
  XStart := 0;
  YStart := 1;

  ZeroMemory(Addr(TempMap), SizeOf(TempMap));

  {$R-}
  while True do
  begin
    X := XStart;
    Y := YStart;
    while (X <= 44) and (Y >= 0) do
    begin
      TempMap[X, Y][0] := TempArray[i];
      TempMap[X, Y][1] := TempArray[i+1];
      TempMap[X+1, Y][0] := TempArray[i];
      TempMap[X+1, Y][1] := TempArray[i+1];
      TempMap[X, Y+1][0] := TempArray[i];
      TempMap[X, Y+1][1] := TempArray[i+1];
      Inc(i, 2);
      Inc(X, 1);
      Dec(Y, 1);
    end;
    if YStart < 43 then
    begin
      Inc(YStart, 2);
    end
    else if YStart = 43 then
    begin
      Inc(YStart, 1);
      Inc(XStart, 1);
    end
    else // YStart = 44
    begin
      Inc(XStart, 2);
    end;
    if XStart > 43 then Break;
  end;

  begin
    for Y := 0 to 44 do
    begin
      P := Bitmap.ScanLine[Y];
      for X := 0 to 44 do
      begin
        P[X*2{15Bit}  ] := TempMap[X, Y][0];
        P[X*2{15Bit}+1] := TempMap[X, Y][1];
      end;
    end;
  end;
  {$R+}

  Result := True;
end;

function FileNamesCorrect:boolean;
begin
  with WFMapEditForm do
  begin
    if (MapEdit.Color = clGreen) and
       (UOPathEdit.Color = clGreen)
      then
      begin
        Result := True;
        if (MapEdit.Tag = 1) or (UOPathEdit.Tag = 1) then // one has changed
        begin
          //SaveFileNames(MapEdit.Text, UOPathEdit.Text);
          MapEdit.Tag := 0;
          UOPathEdit.Tag := 0;
        end;
      end
      else Result := False;
  end;
end;

// 2004/07/06 Shinigami - Brushes can use up to 20x20 tiles now
// 2004/07/06 Shinigami - BrushesEdit will show choosen Brush
procedure TWFCustomBrush.loadBrush(brushName: String);
var
 i, x, y : integer;
 myBrush : TrBrush;
begin
  If brushName='' Then Begin // Shinigami
    for x := 0 to BrushGrid.ColCount -1 do
      for y := 0 to BrushGrid.RowCount -1 do
        BrushGrid.Cells[x,y] := 'NODRAW';
  End Else Begin
    BrushGrid.RowCount := udRows.Max; // Shinigami
    BrushGrid.ColCount := udCols.Max;
    for x := 0 to BrushGrid.ColCount -1 do
      for y := 0 to BrushGrid.RowCount -1 do
        BrushGrid.Cells[x,y] := 'NODRAW';
    BrushGrid.ColCount := 1;
    BrushGrid.RowCount := 1;
    FBrush.Clear;
    edBrushName.Text := brushName;
    FBrush.LoadFromFile(MainForm.Appath+'Brushes\'+brushName+'.brs');
    for i := 0 to FBrush.Count -1 do
    begin
      myBrush := TextToBrush(',',FBrush.Strings[i]);
      BrushGrid.Cells[myBrush.Col,myBrush.Row] := '$'+IntToHex(myBrush.id,4);
      if myBrush.Col >= BrushGrid.ColCount-1 then
        BrushGrid.ColCount := myBrush.Col+1;
      if myBrush.Row >= BrushGrid.RowCount-1 then
        BrushGrid.RowCount := myBrush.Row+1;
    end;
    udRows.Position := BrushGrid.RowCount;
    udCols.Position := BrushGrid.ColCount;
    edCols.Text := IntToStr(udCols.Position);
    edRows.Text := IntToStr(udRows.Position);
  End;
end;

// 2004/07/06 Shinigami - BrushesEdit will show choosen Brush
procedure TWFCustomBrush.FormCreate(Sender: TObject);
var
  i: integer;
  idlist : TStringList;
  ahex : string;
  aint : integer;
begin
  FBrush := TStringList.Create;
  idlist := TStringList.Create;
  idlist.LoadFromFile(MainForm.Appath+'Textures\tileids.lst');
  smallDrawGrid.RowCount := idlist.Count+1;
  smallDrawGrid.Cells[0,0] := 'NODRAW';
  for i := 1 to smallDrawGrid.RowCount-1 do
  begin
    aint := StrToInt(copy(idlist[i-1],Pos('=',idlist[i-1])+1,length(idlist[0])));
    ahex := IntToHex(aint,4);
    smallDrawGrid.Cells[0,i] := ahex;
  end;
  idlist.Free;
  smallDrawGrid.Repaint;
end;

// 2004/07/06 Shinigami - BrushesEdit will show choosen Brush
Procedure TWFCustomBrush.FormShow(Sender: TObject);
Begin
  If cbCustomBrushes.ItemIndex<>-1 Then loadBrush(cbCustomBrushes.Text) Else loadBrush('');
End;

function TWFCustomBrush.findRow(id : integer): integer;
var
  i : integer;
  a : string;
begin
  result := -1;
  for i := 0 to smallDrawGrid.RowCount -1 do
  begin
    a := copy(smallDrawGrid.Rows[i].Text,0,4);
    if not(a = 'NODR') and (StrToInt('$'+a) = id) then
    begin
      result := i;
      break;
    end;
  end;
end;

procedure TWFCustomBrush.BrushGridDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  Bitmap: TBitmap;
 // MapCell: TMapCell;
 // XBlock, YBlock, XOff, YOff: integer;
 // iColor : integer;
  {i, }id : integer;
 // rborder : TRect;
begin
  Bitmap := TBitmap.Create;
  Bitmap.Width := 1; // LoadXYZ sets them
  Bitmap.Height := 1;
  Bitmap.PixelFormat := pf15bit;
  if BrushGrid.Cells[aCol, aRow] = '' then
    BrushGrid.Cells[aCol, aRow] := 'NODRAW';
  if BrushGrid.Cells[aCol, aRow] = 'NODRAW' then
    Bitmap.LoadFromResourceName(HInstance, 'BRUSHNODRAW')
  else
  begin
    id := StrToInt(copy(BrushGrid.Cells[ACol,ARow],0,5));
    if not LoadTexture(id, Bitmap) then
      if not LoadArt(id, Bitmap) then
      begin
      end;
  end;
  BrushGrid.Canvas.StretchDraw(Rect, Bitmap);
  if gdSelected	in State then
  begin
    BrushGrid.Canvas.Pen.Color := clRed;
    BrushGrid.Canvas.Brush.Style := bsClear;
    BrushGrid.Canvas.Rectangle(Rect);
  end;
  Bitmap.Free;
end;

procedure TWFCustomBrush.edBrushNameChange(Sender: TObject);
begin
  if edBrushName.Text = '' then
    edBrushName.Color := clRed
  else
    edBrushName.Color := clGreen;
end;

procedure TWFCustomBrush.smallDrawGridDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  Bitmap: TBitmap;
  id : integer;
begin
  id:=0;
  Bitmap := TBitmap.Create;
  Bitmap.Width := 1; // LoadXYZ sets them
  Bitmap.Height := 1;
  Bitmap.PixelFormat := pf15bit;
  //SortedTextureGrid.
  if copy(smallDrawGrid.Rows[ARow].Text,0,6) = 'NODRAW' then
    Bitmap.LoadFromResourceName(HInstance, 'BRUSHNODRAW')
  else
  begin
    id := StrToInt('$'+copy(smallDrawGrid.Rows[ARow].Text,0,4));
    if not LoadTexture(id, Bitmap) then
      if not LoadArt(id, Bitmap) then
      begin
      end;
  end;
  smallDrawGrid.Canvas.StretchDraw(Rect, Bitmap);
  if gdSelected in State then
  begin
    smallDrawGrid.Canvas.Pen.Color := clRed;
    smallDrawGrid.Canvas.Brush.Style := bsClear;
    smallDrawGrid.Canvas.Rectangle(Rect);
  end;
  smallDrawGrid.Canvas.Brush.Style := bsSolid;
  smallDrawGrid.Canvas.Brush.Color := clWhite; // default
  if cbShowID.Checked then
    if copy(smallDrawGrid.Rows[ARow].Text,0,6) = 'NODRAW' then
      smallDrawGrid.Canvas.TextOut(Rect.Left+1, Rect.Top+1, 'nodraw')
    else
      smallDrawGrid.Canvas.TextOut(Rect.Left+1, Rect.Top+1, ' '+IntToSpacedHex(id, 2)+' ');
  Bitmap.Free;
end;

procedure TWFCustomBrush.smallDrawGridClick(Sender: TObject);
var
  id : integer;
begin
  if copy(smallDrawGrid.Rows[smallDrawGrid.Row].Text,0,6) = 'NODRAW' then
    id := -1
  else
    id := StrToInt('$'+copy(smallDrawGrid.Rows[smallDrawGrid.Row].Text,0,4));
  BrushGrid.Tag := Id;
end;

procedure TWFCustomBrush.BrushGridSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
  if BrushGrid.Tag = -1 then
    BrushGrid.Cells[ACol,ARow] := 'NODRAW'
  else
    BrushGrid.Cells[ACol,ARow] := '$'+IntToHex(BrushGrid.Tag,4);
end;

procedure TWFCustomBrush.udRowsClick(Sender: TObject; Button: TUDBtnType);
begin
  edRows.Text := IntToStr(udRows.Position);
  BrushGrid.RowCount := udRows.Position;
end;

procedure TWFCustomBrush.udColsClick(Sender: TObject; Button: TUDBtnType);
begin
  edCols.Text := IntToStr(udCols.Position);
  BrushGrid.ColCount := udCols.Position;
end;

procedure TWFCustomBrush.btnFindClick(Sender: TObject);
var
  index : integer;
  rRect : TRect;
begin
  if edFindID.Text <> '' then
  begin
    index := FindRow(StrToInt('$'+edFindID.Text));
    if index > -1 then
    begin
      smallDrawGrid.Repaint;
      BrushGrid.Tag := StrToInt('$'+edFindID.Text);
      smallDrawGrid.TopRow := index;
      smallDrawGrid.Canvas.Pen.Color := clRed;
      smallDrawGrid.Canvas.Brush.Style := bsClear;
      rRect := smallDrawGrid.CellRect(0, index);
      smallDrawGrid.Canvas.Rectangle(rRect);
    end;
  end;
end;

procedure TWFCustomBrush.cbShowIDClick(Sender: TObject);
begin
  smallDrawGrid.Repaint;
end;

procedure TWFCustomBrush.BitBtn1Click(Sender: TObject);
var
  x,y : integer;
  brushName : String;
  abrush : TStringList;
begin
  // Brush speichern
  abrush := TStringList.Create;
  if edBrushName.Color = clRed then
     brushName := inputBox('Brush name','Select a brush name','')
  else
    brushName := edBrushName.Text;
  if brushName <> '' then
  begin
    for x := 0 to BrushGrid.ColCount -1 do
      for y := 0 to BrushGrid.RowCount -1 do
        if BrushGrid.Cells[x,y] <> 'NODRAW' then
          abrush.Add(IntToStr(x)+','+IntToStr(y)+','+copy(BrushGrid.Cells[x,y],0,5));
    abrush.SaveToFile(MainForm.Appath+'Brushes\'+brushName+'.brs');
  end;
  abrush.Free;
end;

procedure TWFCustomBrush.cbCustomBrushesChange(Sender: TObject);
begin
  LoadBrush(cbCustomBrushes.Text);
end;

procedure TWFCustomBrush.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  FBrush.Free;
end;

end.
